program acm_codigo_de_acceso(input,output);

uses dos;

var nombre,nombre_acm : string[12];
    sn : char;

procedure entrada;
var n : integer;
    cod, code : string[6];
begin
     cod := 'system';
     writeln;
     writeln;
     writeln('IBM Personal System/2 - Protector de Ejecucin de Archivos');
     writeln('Versin 2.00 ');
     writeln('(C)Copyright IBM Corp 1991, 1994 ');
     writeln('(C)Copyright ACM Software 1991, 1994 ');
     writeln;
     write('Introduzca codigo de acceso: ');
     readln(code);
     if code = cod then
       begin
            writeln;
            writeln('Codigo correcto, acceso permitido. ');
            writeln;
       end
     else
       begin
            writeln;
            writeln('Codigo incorrecto, acceso denegado. ');
            writeln;
            halt;
       end;
     write('Nombre del fichero original: ');
     readln(nombre);
     nombre_acm := nombre;
     n := 1;
     while nombre_acm[n] <> '.' do n := n + 1;
     n := n + 1;
     nombre_acm[n] := 'a';
     nombre_acm[n+1] := 'c';
     nombre_acm[n+2] := 'm';
end;

function buscar_acm : boolean;
var d : SearchRec;
    aux : boolean;
begin
     aux := false;
     FindFirst(nombre_acm,archive,d);
     if DosError = 0 then aux := true;
     buscar_acm := aux;
end;

procedure crear_acm;
var f_viejo,f_nuevo,f_acm : file of byte;
    n : integer;
    x,acm : byte;
begin
     acm := 0;
     assign(f_viejo,nombre);
     assign(f_nuevo,'acm.acm');
     assign(f_acm,nombre_acm);
     reset(f_viejo);
     rewrite(f_acm);
     rewrite(f_nuevo);
     for n := 1 to 1024 do
        begin
             read(f_viejo,x);
             write(f_acm,x);
             write(f_nuevo,acm);
        end;
     while not eof(f_viejo) do
          begin
               read(f_viejo,x);
               write(f_nuevo,x);
          end;
     close(f_viejo);
     close(f_nuevo);
     close(f_acm);
     erase(f_viejo);
     rename(f_nuevo,nombre);
end;

procedure deshacer_acm;
var f_viejo,f_nuevo,f_acm : file of byte;
    n : integer;
    x,y : byte;
begin
     assign(f_viejo,nombre);
     assign(f_nuevo,'acm.acm');
     assign(f_acm,nombre_acm);
     reset(f_viejo);
     reset(f_acm);
     rewrite(f_nuevo);
     for n := 1 to 1024 do
        begin
             read(f_viejo,y);
             read(f_acm,x);
             write(f_nuevo,x);
        end;
     while not eof(f_viejo) do
          begin
               read(f_viejo,x);
               write(f_nuevo,x);
          end;
     close(f_viejo);
     close(f_nuevo);
     close(f_acm);
     erase(f_viejo);
     erase(f_acm);
     rename(f_nuevo,nombre);
end;

procedure operar;
begin
     if buscar_acm then
       begin
            writeln;
            writeln('Fichero ACM encontrado ');
            writeln;
            write('Desea que el archivo ',nombre,' pueda volver a ejecutarse?   S/N    ');
            readln(sn);
            if (sn = 'S') or (sn = 's') then
              begin
                   writeln;
                   writeln('Posibilitando ejecucin...');
                   writeln;
                   deshacer_acm;
                   writeln('Ejecucin posibilitada, fichero ',nombre,' recuperado.');
                   writeln;
              end
       end
     else
       begin
            writeln;
            writeln('Fichero ACM no existe ');
            writeln;
            write('Desea imposibilitar la ejecucin de ',nombre,'?   S/N    ');
            readln(sn);
            if (sn = 'S') or (sn = 's') then
              begin
                   writeln;
                   writeln('Imposibilitando ejecucin...');
                   writeln;
                   crear_acm;
                   writeln('Ejecucin imposibilitada, fichero ',nombre_acm,' creado.');
                   writeln;
              end;
       end;
end;

BEGIN

     entrada;
     operar;

END.


