program avisos(input,output,f,f1);

uses crt,dos,drivers;

type fech = record
         dia,mes,ano : integer;
    end;

type registro = record
             num   : integer;
             ref   : string[79];
             fecha : fech;
    end;

var opcion : (inicializa,introduce,borra,revisa,renumerar,purgar,ayuda);
    f,f1   : file of registro;
    reg    : registro;
    cop    : string[36];
    opc    : integer;
    prog,fichero,ficherobak : string[17];

label seguir;

procedure cuadro;
begin
     clrscr;
     writeln('ͻ');
     writeln('                                                                           ');
     writeln(' Este programa ha sido donado por el autor para el dominio pblico, por lo ');
     writeln(' cual su distribucin es libre y gratuita estanto totalmente libre de toda ');
     writeln(' carga econmica. El autor  no  se  responsabiliza de cualquier dao, que, ');
     writeln(' directa o indirectamente, este programa pueda causar,  bien  sea un  dao ');
     writeln(' relativo al software o al hardware.                                       ');
     writeln('                                                                           ');
     writeln(' Autor: Alvaro Canteiro Martinez.      Internet: siacamaa@sisz00.si.ehu.es ');
     writeln('                                        FidoNet: 2:344/17.25               ');
     writeln('ͼ');
     writeln;
     halt;
end;

procedure inicializar;
var n : integer;
begin
     for n := 1 to 17 do
        begin
             prog[n] := ' ';
             fichero[n] := ' ';
             ficherobak[n] := ' ';
        end;
     fichero    := 'c:\dos\avisos.dat';
     ficherobak := 'c:\dos\avisos.bak';
     prog       := 'c:\dos\avisos.exe';
     opc := 0;
end;


procedure fin;
begin
     textcolor(7);
     textbackground(0);
     cuadro;
end;


function contar_registros : integer;
var n : integer;
begin
     assign(f,fichero);
     reset(f);
     n := 0;
     while not eof(f) do
          begin
               read(f,reg);
               n := n + 1;
          end;
     close(f);
     contar_registros := n;
end;


procedure escribir_opcion(opc : integer);
begin
     if opc = 0 then write('0  =>  Salir al Sistema Operativo');
     if opc = 1 then write('1  =>  Inicializar archivo de avisos');
     if opc = 2 then write('2  =>  Introducir avisos en archivo');
     if opc = 3 then write('3  =>  Borrar avisos de archivo');
     if opc = 4 then write('4  =>  Revisar avisos en archivo');
     if opc = 5 then write('5  =>  Reenumerar los registros');
     if opc = 6 then write('6  =>  Purgar avisos pasados de fecha');
     if opc = 7 then write('7  =>  Mostrar pantalla de ayuda');
end;


procedure poner_marca(opc : integer);
begin
     gotoxy(15,10+opc);
     textcolor(1);
     textbackground(7);
     escribir_opcion(opc);
     textcolor(7);
     textbackground(1);
end;


procedure borrar_marca(opc : integer);
begin
     gotoxy(15,10+opc);
     escribir_opcion(opc);
end;


procedure pantalla_ayuda;
var z : char;
begin
     clrscr;
     writeln;
     writeln('                      ͻ');
     writeln('                        AYUDA PARA AVISOS VERSION 1.0  ');
     writeln('                      ͼ');
     writeln;
     writeln('-------------------------------------------------------------------------------');
     writeln;
     writeln(' El menu principal tiene 6 opciones, cada opcin hace los siguiente: ');
     writeln;
     writeln(' - Salir al Sistema Operativo: finaliza la ejecucin de Avisos.');
     writeln(' - Inicializar Archivo de Datos: esta opcin solo  se  debe  usar  cuando se');
     writeln('   quiera crear el fichero de datos(porque este no exista) o cuando se desee');
     writeln('   borrar todos los datos que contenga el fichero actual.');
     writeln(' - Introducir avisos en archivo: sirve para introducir los avisos.');
     writeln(' - Borrar avisos de archivo: con esta opcin  el  programa  pide  el  nmero');
     writeln('   de registro del aviso que se desee borrar, y posteriormente lo borra.');
     writeln(' - Revisar avisos en archivo: con  esta  opcin  se  muestran  por  pantalla');
     writeln('   todos los avisos acumulados en el fichero de avisos.');
     writeln(' - Reenumerar los registros: esta opcin asigna a cada  registro  un  nmero');
     writeln('   entero que sea sucesor del registro anterior y predecesor del siguiente.');
     writeln(' - Purgar avisos pasados de fecha: esta opcin elimina del fichero todos los');
     writeln('   avisos anteriores a la fecha actual.');
     writeln;
     writeln('-------------------------------------------------------------------------------');
     z := readkey;
end;


function seleccionar_opcion(nop : integer) : integer;
var retorno : boolean;
    z : char;
begin
     retorno := false;
     repeat
           z := readkey;
           if (z = chr(72)) or (z = chr(80)) then
              begin
                   borrar_marca(nop);
                   if z = chr(72) then if nop <> 0 then nop := nop - 1 else nop := 7;
                   if z = chr(80) then if nop <> 7 then nop := nop + 1 else nop := 0;
                   poner_marca(nop);
              end
                 else if z = chr(13) then retorno := true
     until retorno;
     seleccionar_opcion := nop;
end;


procedure copyright;
var n : integer;
begin
     cop := '-H.Htu~wnlmy%FHR%Xtky|fwj%X3F3%6>>83';
     for n := 1 to 36 do cop[n] := chr(ord(cop[n])-5);
end;


procedure elejir_opcion;
begin
     textcolor(7);
     textbackground(1);
     clrscr;
     gotoxy(20,20);
     write(cop);
     gotoxy(21,3);
     writeln('ͻ');
     gotoxy(21,4);
     writeln(' CONTROLADOR DE AVISOS PARA SISTEMAS IBM ');
     gotoxy(21,5);
     writeln('ͼ');
     gotoxy(35,7);
     write('Version 1.0');
     gotoxy(15,10); escribir_opcion(0);
     gotoxy(15,11); escribir_opcion(1);
     gotoxy(15,12); escribir_opcion(2);
     gotoxy(15,13); escribir_opcion(3);
     gotoxy(15,14); escribir_opcion(4);
     gotoxy(15,15); escribir_opcion(5);
     gotoxy(15,16); escribir_opcion(6);
     gotoxy(15,17); escribir_opcion(7);
     poner_marca(opc);
     opc := seleccionar_opcion(opc);
     if opc = 0 then fin;
     if opc = 1 then opcion := inicializa;
     if opc = 2 then opcion := introduce;
     if opc = 3 then opcion := borra;
     if opc = 4 then opcion := revisa;
     if opc = 5 then opcion := renumerar;
     if opc = 6 then opcion := purgar;
     if opc = 7 then opcion := ayuda;
end;


procedure ejecutar_opcion;

   procedure inicializa_fichero;
   var z : char;
   begin
        clrscr;
        gotoxy(12,12);
        write(' Seguro que desea inicializar el fichero de avisos?  S/N  ');
        z := readkey;
        if (z <> 'S') and (z <> 's') then exit;
        assign(f,fichero);
        rewrite(f);
        close(f);
   end;

   procedure introduce_datos;
   var f1 : file of registro;
       fe : string[10];
       n,num : integer;
       procedure copia;
       begin
            assign(f,fichero);
            assign(f1,ficherobak);
            reset(f);
            rewrite(f1);
            while not eof(f) do
                 begin
                      read(f,reg);
                      write(f1,reg);
                  end;
            close(f);
            erase(f);
       end;
   begin
        clrscr;
        num := contar_registros;
        copia;
        writeln;
        writeln('Teclee /FIN en entrada referencia para acabar');
        repeat
              writeln;
              for n := 1 to 79 do reg.ref := ' ';
              write('         Referencia: ');
              readln(reg.ref);
              if (reg.ref = '/FIN') or (reg.ref = '/fin') then
                begin
                     close(f1);
                     rename(f1,fichero);
                     exit;
                end;
               write(' Fecha (dd-mm-aaaa): ');
               readln(fe);
               reg.fecha.dia := ((ord(fe[1])-48) * 10) + (ord(fe[2])-48);
               reg.fecha.mes := ((ord(fe[4])-48) * 10) + (ord(fe[5])-48);
               reg.fecha.ano := ((ord(fe[7])-48) * 1000) + ((ord(fe[8])-48) * 100) + ((ord(fe[9])-48)*10) + (ord(fe[10])-48);
               num := num + 1;
               reg.num := num;
               write(f1,reg);
        until (reg.ref = '/FIN') or (reg.ref = '/fin');
        close(f1);
        rename(f1,'c:\dos\avisos.dat');
   end;

   procedure borra_datos;
   var n : integer;
   begin
        clrscr;
        gotoxy(12,12);
        write(' Introduzca numero de registro a borrar: ');
        readln(n);
        clrscr;
        gotoxy(28,12);
        write('Reestructurando archivo...');
        assign(f,fichero);
        assign(f1,ficherobak);
        reset(f);
        rewrite(f1);
        while not eof(f) do
             begin
                  read(f,reg);
                  if reg.num <> n then write(f1,reg);
              end;
        close(f);
        close(f1);
        erase(f);
        rename(f1,fichero);
   end;

   procedure revisa_datos;
   var n,nreg : integer;
       z : char;
       procedure parar;
       var z : char;
       begin
            writeln;
            write(' Pulse una tecla para continuar...');
            z := readkey;
       end;
   begin
        nreg := contar_registros;
        if nreg = 0 then
          begin
               clrscr;
               gotoxy(26,12);
               write('No hay avisos en el fichero.');
               z := readkey;
               exit;
          end;
        clrscr;
        n := 0;
        assign(f,fichero);
        reset(f);
        writeln;
        writeln(' Nmero de registros = ',nreg);
        while not eof(f) do
             begin
                  n := n + 1;
                  writeln;
                  read(f,reg);
                  writeln('   Nm. Reg: ',reg.num);
                  writeln(' Referencia: ',reg.ref);
                  writeln('      Fecha: ',reg.fecha.dia,'-',reg.fecha.mes,'-',reg.fecha.ano);
                  if n = 5 then
                    begin
                         n := 0;
                         parar;
                         clrscr;
                    end;
             end;
        close(f);
        if n <> 0 then parar;
   end;

   procedure renumerar_registros;
   var n : integer;
   begin
        clrscr;
        gotoxy(28,12);
        write('Reenumerando registros...');
        n := 0;
        assign(f,fichero);
        assign(f1,ficherobak);
        reset(f);
        rewrite(f1);
        while not eof(f) do
             begin
                  n := n + 1;
                  read(f,reg);
                  reg.num := n;
                  write(f1,reg);
             end;
        close(f);
        close(f1);
        erase(f);
        rename(f1,fichero);
   end;

   procedure purgar_registros;
   var ano,mes,dia,d : word;
       function fecha_pasada(r : registro) : boolean;
       begin
            if r.fecha.ano < ano then fecha_pasada := true
              else if r.fecha.ano > ano then fecha_pasada := false
                  else if r.fecha.mes < mes then fecha_pasada := true
                      else if r.fecha.mes > mes then fecha_pasada := false
                          else if r.fecha.dia < dia then fecha_pasada := true
                              else if r.fecha.dia > dia then fecha_pasada := false
                                  else if r.fecha.dia = dia then fecha_pasada := false;
       end;
   begin
        clrscr;
        gotoxy(28,12);
        write('Purgando registros...');
        getdate(ano,mes,dia,d);
        assign(f,fichero);
        assign(f1,ficherobak);
        reset(f);
        rewrite(f1);
        while not eof(f) do
             begin
                  read(f,reg);
                  if not fecha_pasada(reg) then write(f1,reg);
             end;
        close(f);
        close(f1);
        erase(f);
        rename(f1,fichero);
   end;

begin
     if opcion = introduce  then introduce_datos;
     if opcion = borra      then borra_datos;
     if opcion = inicializa then inicializa_fichero;
     if opcion = revisa     then revisa_datos;
     if opcion = renumerar  then renumerar_registros;
     if opcion = purgar     then purgar_registros;
     if opcion = ayuda      then pantalla_ayuda;
end;


BEGIN

     initsyserror;
     copyright;
     inicializar;
     seguir:
     elejir_opcion;
     ejecutar_opcion;
     goto seguir;

END.
