program configurador(input,output,f1);

(* Este programa realiza la configuracin de un IBM 30-286 bajo DOS 5.0 *)

uses crt,dos,drivers;

var opcion : integer;
    config : (cache,cachere,maxmem,virtual);
    f1 : text;

procedure cuadro;
begin
     clrscr;
     writeln('ͻ');
     writeln('                                                                           ');
     writeln(' Este programa ha sido donado por el autor para el dominio pblico, por lo ');
     writeln(' cual su distribucin es libre y gratuita estanto totalmente libre de toda ');
     writeln(' carga econmica. El autor  no  se  responsabiliza de cualquier dao, que, ');
     writeln(' directa o indirectamente, este programa pueda causar,  bien  sea un  dao ');
     writeln(' relativo al software o al hardware.                                       ');
     writeln('                                                                           ');
     writeln(' Autor: Alvaro Canteiro Martinez.      Internet: siacamaa@sisz00.si.ehu.es ');
     writeln('                                        FidoNet: 2:344/17.25               ');
     writeln('ͼ');
     writeln;
     halt;
end;


procedure fin;
begin
     textcolor(7);
     textbackground(0);
     cuadro;
end;


procedure crea_config;
begin

     if config = maxmem  then writeln(f1,'FILES=8');
     if config = virtual then writeln(f1,'FILES=20');
     if config = cache   then writeln(f1,'FILES=20');
     if config = cachere then writeln(f1,'FILES=20');

     if config = virtual then writeln(f1,'BUFFERS=25,8');
     if config = maxmem  then writeln(f1,'BUFFERS=8');
     if config = cache   then writeln(f1,'BUFFERS=8');
     if config = cachere then writeln(f1,'BUFFERS=8');

     writeln(f1,'STACKS=0,0');
     writeln(f1,'FCBS=1');
     writeln(f1,'BREAK=OFF');
     writeln(f1,'COUNTRY=034,,C:\DOS\COUNTRY.SYS');

     if config = cachere then writeln(f1,'DEVICE=C:\DOS\SETVER.EXE');

     writeln(f1,'DEVICE=C:\DOS\HIMEM.SYS');
     writeln(f1,'DOS=HIGH,UMB');

     if config = cachere then
       begin
            writeln(f1,'DEVICE=C:\DOS\SMARTDRV.SYS 256');
            writeln(f1,'DEVICE=C:\DOS\RAMDRIVE.SYS 51 512 16 /E');
       end;
     if config = cache then writeln(f1,'DEVICE=C:\DOS\SMARTDRV.SYS 320');
     if config = virtual then writeln(f1,'DEVICE=C:\DOS\RAMDRIVE.SYS 320 512 64 /E');

     if config <> maxmem then writeln(f1,'INSTALL=C:\DOS\KEYB.COM SP,,C:\DOS\KEYBOARD.SYS');

     if config = cachere then
       begin
            writeln(f1,'INSTALL=C:\DOS\FASTOPEN.EXE C:=(68,68) D:=(40,40)');
            writeln(f1,'INSTALL=C:\DOS\DOSKEY.COM');
       end;
end;

procedure crea_autoexec;
begin
     writeln(f1,'@ECHO OFF');
     writeln(f1,'PROMPT $P$G');

     if config = cachere then
       begin
            writeln(f1,'COPY C:\COMMAND.COM E:');
            writeln(f1,'SET COMSPEC=E:\COMMAND.COM');
       end;

     if config <> maxmem then writeln(f1,'PATH C:\DOS;C:\WORK\VARIOS');

     writeln(f1,'C:\DOS\LOGOTIPO');
     writeln(f1,'CD WORK');

     writeln(f1,'VOL C:');
     writeln(f1,'VOL D:');

     if config = cachere then writeln(f1,'VOL E:');
     if config = virtual then writeln(f1,'VOL E:');

     writeln(f1,'VER');

end;

procedure escribir_opcion(opc : integer);
begin
     if opc = 0 then write('0  =>  Salir sin Configurar');
     if opc = 1 then write('1  =>  Configuracin Cach');
     if opc = 2 then write('2  =>  Configuracin Normal de Trabajo');
     if opc = 3 then write('3  =>  Configuracin Unidad Virtual de 320k');
     if opc = 4 then write('4  =>  Configuracin Mxima Memoria Libre');
     if opc = 5 then write('5  =>  Anular Config y Autoexec');
end;

procedure poner_marca(opc : integer);
begin
     gotoxy(7,8+opc);
     textcolor(1);
     textbackground(7);
     escribir_opcion(opc);
     textcolor(7);
     textbackground(1);
end;

procedure borrar_marca(opc : integer);
begin
     gotoxy(7,8+opc);
     escribir_opcion(opc);
end;

function seleccionar_opcion(nop : integer) : integer;
var retorno : boolean;
    z : char;
begin
     retorno := false;
     repeat
           z := readkey;
           if (z = chr(72)) or (z = chr(80)) then
              begin
                   borrar_marca(nop);
                   if z = chr(72) then if nop <> 0 then nop := nop - 1 else nop := 5;
                   if z = chr(80) then if nop <> 5 then nop := nop + 1 else nop := 0;
                   poner_marca(nop);
              end
           else if z = chr(13) then retorno := true;
     until retorno;
     seleccionar_opcion := nop;
end;

procedure elejir_opcion;
  procedure anular;
  begin
       textbackground(0);
       clrscr;
       writeln;
       assign(f1,'c:\config.sys');
       erase(f1);
       writeln(' CONFIG.SYS borrado.');
       assign(f1,'c:\autoexec.bat');
       erase(f1);
       writeln(' AUTOEXEC.BAT borrado.');
       writeln;
       halt;
  end;
begin
     textcolor(7);
     textbackground(1);
     clrscr;
     gotoxy(14,20);
     write('(C)Copyright ACM Software S.A. 1993');
     gotoxy(21,3);
     writeln('CONFIGURADOR PARA IBM PS/2 286');
     gotoxy(21,4);
     writeln('==============================');
     gotoxy(14,6);
     writeln('Este configurador solo es valido bajo DOS 5.0');
     gotoxy(7,8);  escribir_opcion(0);
     gotoxy(7,9);  escribir_opcion(1);
     gotoxy(7,10); escribir_opcion(2);
     gotoxy(7,11); escribir_opcion(3);
     gotoxy(7,12); escribir_opcion(4);
     gotoxy(7,13); escribir_opcion(5);
     opcion := 0;
     poner_marca(opcion);
     opcion := seleccionar_opcion(0);
     if opcion = 0 then fin;
     if opcion = 1 then config := cache;
     if opcion = 2 then config := cachere;
     if opcion = 3 then config := virtual;
     if opcion = 4 then config := maxmem;
     if opcion = 5 then anular;
     textcolor(7);
     textbackground(0);
end;

procedure configurar;
begin
     clrscr;
     writeln;
     write(' Nmero de opcin seleccionada:  ');
     escribir_opcion(opcion);
     assign(f1,'c:\config.sys');
     rewrite(f1);
     crea_config;
     close(f1);
     writeln;
     writeln;
     writeln(' Fichero CONFIG.SYS modificado.');
     assign(f1,'c:\autoexec.bat');
     rewrite(f1);
     crea_autoexec;
     close(f1);
     writeln(' Fichero AUTOEXEC.BAT modificado.');
     writeln;
end;

procedure comprobar_version;
var n1,n2 : byte;
    z : char;
  function comprobar : boolean;
  begin
       comprobar := false;
       n1 := lo(dosversion);
       n2 := hi(dosversion);
       if (n1 = 5) and (n2 = 0) then comprobar := true;
  end;
begin
     if not comprobar then
       begin
            writeln;
            writeln(' Se ha detectado DOS Versin ',n1,'.',n2);
            writeln(' Este programa solo es valido con DOS Versin 5.0');
            writeln;
            write(' Desea continuar? S/N ');
            z := readkey;
            if (z <> 'S') and (z <> 's') then halt;
       end;
end;


BEGIN

     initsyserror;
     comprobar_version;
     elejir_opcion;
     configurar;
     cuadro;

END.