unit errores;

interface

implementation

var oldexit : pointer;

function wherex : byte; assembler;
asm
    mov ah,3
    mov bh,0
    int 10h
    inc dl
    mov al,dl
end;

procedure RunTimeExitProc;Far;
var Mensaje : String;
begin
     if ErrorAddr <> nil then
       begin
            case ExitCode Of
              
                (* Errores Dos *)               

                1 : Mensaje := 'Nmero n vlido de funcin';
                2 : Mensaje := 'Archivo no encontrado';
                3 : Mensaje := 'Via de acceso no encontrada';
                4 : Mensaje := 'Demasiados archivos abiertos';
                5 : Mensaje := 'Acceso al archivo denegado';
                6 : Mensaje := 'Manipulacin de archivos no vlida';
                8 : Mensaje := 'Memoria insuficiente';
               12 : Mensaje := 'Cdigo de acceso al archivo no vlido';
               15 : Mensaje := 'Nmero de unidad no vlido';
               16 : Mensaje := 'No se puede eliminar el directorio actual';
               17 : Mensaje := 'No se puede renombrar entre unidades';
               18 : Mensaje := 'No mas archivos';
               
               (* Errores de Entrada/Salida *)

              100 : Mensaje := 'Error de lectura de disco';
              101 : Mensaje := 'Error de escritura de disco';
              102 : Mensaje := 'Archivo no encontrado';
              103 : Mensaje := 'Archivo no abierto';
              104 : Mensaje := 'Archivo no abierto para entrada';
              105 : Mensaje := 'Archivo no abierto para salida';
              106 : Mensaje := 'Formato numrico no vlido';
              
              (* Errores crticos *)

              150 : Mensaje := 'Disco protegido contra escritura';
              151 : Mensaje := 'Unidad desconocida';
              152 : Mensaje := 'Unidad no preparada';
              153 : Mensaje := 'Orden desconocida';
              154 : Mensaje := 'Error CRC en datos';
              156 : Mensaje := 'Error en busqueda de disco';
              157 : Mensaje := 'Tipo de soporte desconocido';
              158 : Mensaje := 'Sector no encontrado';
              159 : Mensaje := 'Falta papel en la impresora';
              160 : Mensaje := 'Fallo de escritura en dispositivo';
              161 : Mensaje := 'Fallo de lectura en dispositivo';
              162 : Mensaje := 'Fallo en hardware';
              
              (* Errores fatales *)

              200 : Mensaje := 'Divisin por cero';
              201 : Mensaje := 'Error de comprobacin de rango';
              202 : Mensaje := 'Error de desbordamiento de pila (Stack)';
              203 : Mensaje := 'Error de desbordamiento de pila (Heap)';
              204 : Mensaje := 'Operacin de puntero no vlida';
              205 : Mensaje := 'Desbordamiento alto de coma flotante';
              206 : Mensaje := 'Desbordamiento bajo de coma flotante';
              207 : Mensaje := 'Operacin de coma flotante no vlida';
              208 : Mensaje := 'Manipulador de recubrimiento no isntalado';
              209 : Mensaje := 'Error de lectura en archivo overlay';
              210 : Mensaje := 'Objeto no inicializado';
              211 : Mensaje := 'Llamada a mtodo abstracto';
              212 : Mensaje := 'Error en registro de flujo Stream';
              213 : Mensaje := 'Indice de collectin fuera de rango';
              214 : Mensaje := 'Error de desbordamiento de collection';
              215 : Mensaje := 'Error aritmtico de desbordamiento';
              216 : Mensaje := 'Error en proteccin general';
              ELSE Mensaje := 'Error sin descripcin';
            end;
            if wherex <> 1 then writeln;
            writeln('ERROR(',exitcode,'): ',mensaje,'.');
            writeln;
            erroraddr :=nil;
       end;
       exitproc := oldexit;
end;

BEGIN

     OldExit := ExitProc;
     ExitProc := @RunTimeExitProc;

END.     
     