program facturacion(input,output);

type estado = (aldia,atrasada,delincuente);
     linea  = packed array [1..30] of char;
     fecha  = record
                mes : 1..12;
                dia : 1..31;
                ano : 1900..2100;
              end;
     cuenta = record
                nombre : linea;
                calle : linea;
                ciudad : linea;
                clientno : 1..9999;
                clienttipo : estado;
                anteriorsaldo : real;
                nuevosaldo : real;
                pago : real;
                fechapago : fecha;
              end;

var cliente : array [1..100] of cuenta;
    i,n : 1..100;

procedure leerdatos;
var contar : 1..30;
    slash : char;
begin
     for i := 1 to n do
        with cliente[i] do
            begin
                 writeln;
                 writeln('Num. de cliente. ',i:3);
                 write('   Nombre   ');
                 contar := 1;
                 repeat
                 read(nombre[contar]);
                 contar := contar + 1;
                 until eoln;
                 readln;
                 write('   Calle: ');
                 contar := 1;
                 repeat
                       read(calle[contar]);
                       contar := contar + 1;
                       until eoln;
                 readln;
                 write('   Ciudad: ');
                 contar := 1;
                 repeat
                       read(calle[contar]);
                       contar := contar + 1;
                 until eoln;
                 readln;
                 write('   Numero de cuenta: ');
                 readln(clientno);
                 write('   Anterior saldo: ');
                 readln(anteriorsaldo);
                 write('   Pago actual: ');
                 readln(pago);
                 write('   Fecha de pago (mm/dd/aaaa): ');
                 with fechapago do read(mes,slash,dia,slash,ano);
                 readln
            end
end;

procedure procesodatos;
begin
     for i := 1 to n do
        with cliente[i] do
            begin
                 clienttipo := aldia;
                 if (pago > 0) and (pago < 0.1*anteriorsaldo) then clienttipo := atrasada;
                 if (anteriorsaldo > 0) and (pago = 0 ) then clienttipo := delincuente;
                 nuevosaldo := anteriorsaldo+pago
            end
end;

procedure escribirresultado;
begin
     for i := 1 to n do
        with cliente[i] do
            begin
                 writeln;
                 write('Nombre:    ',nombre);
                 writeln('   Numero de cuenta: ',clientno:4);
                 writeln('Calle:  ',calle);
                 writeln('Ciudad: ',ciudad);
                 writeln;
                 write('Antiguo saldo: ',anteriorsaldo:7:2);
                 write('   Pago actual: ',pago:7:2);
                 writeln('   Nuevo saldo: ',nuevosaldo:7:2);
                 writeln;
                 write('Estado de la cuenta: ');
                 case clienttipo of
                    aldia : writeln('AL DIA');
                    atrasada : writeln('ATRASADA');
                    delincuente : writeln('DELINCUENTE');
                 end;
                 writeln
            end
end;

BEGIN

     writeln;
     writeln(' SISTEMA DE FACTURACION A CLIENTES ');
     writeln;
     write('Cuantos clientes hay? ');
     readln(n);
     leerdatos;
     procesodatos;
     escribirresultado

END.

