program generador_de_cartas_de_presentacion(input,output);

uses crt,dos,printer,errores;

var nombre,empresa,direc,cppp,fecha,periodico : string;
    lper : integer;

(* ----------------------------------------------------------------------- *)

procedure inicializacion;
begin
     checkbreak := false;
     nombre  := ' ';
     empresa := ' ';
     direc   := ' ';
     cppp    := ' ';
     fecha   := ' ';
end;

(* ----------------------------------------------------------------------- *)

procedure presentacion;
begin
     clrscr;
     textcolor(lightcyan);
     writeln(' Generador Automtico de Cartas de Presentacin. ');
     writeln(' Versin 0.02');
     writeln(' Autor: Alvaro Canteiro Martinez. 01 de Octubre de 1997. ');
     writeln(' Email Address: alvaro.canteiro@gusgus.subred.org ');
     textcolor(7);
     writeln;
end;

(* ----------------------------------------------------------------------- *)

procedure pedir_datos;
var correjir : boolean;
    z : char;
label a,b,c,d,e,f,seguir;

    (* ------------------------------------------------------------------- *)

    procedure borrar_resto_linea;
    var xcor,ycor,n : integer;
    begin
         xcor := wherex;
         ycor := wherey;
         for n := xcor to 79 do write(' ');
         gotoxy(xcor,ycor);
    end;

    (* ------------------------------------------------------------------- *)

    procedure poner_guiones(num : integer);
    var n : integer;
    begin
         for n := 1 to num do write('_');
    end;

    (* ------------------------------------------------------------------- *)

    procedure leer(x,y : integer; var cad : string; correjir : boolean);
    begin
         gotoxy(x,y);
         textcolor(7);  
         poner_guiones(30);
         gotoxy(x,y); 
         if correjir then 
           begin 
                borrar_resto_linea;
                poner_guiones(30);
                gotoxy(x,y);
           end;
         textcolor(white);
         readln(cad);
    end;

    (* ------------------------------------------------------------------- *)

    procedure leer_periodico(x,y : integer; var cad : string; correjir : boolean);
    begin
         gotoxy(x,y);
         textcolor(7);  
         poner_guiones(17);
         gotoxy(x,y);
         if correjir then
           begin
                borrar_resto_linea;
                poner_guiones(17);
                gotoxy(x,y);
           end;
         textcolor(white);
         readln(cad);
         gotoxy(x,y);
         if (cad = '1') or (cad = '') then cad := 'El Correo Espaol'
           else if cad = '2' then cad := 'El Mundo'
                else if cad = '3' then cad := 'El Pais'
                    else if cad = '4' then cad := 'Deia';
         writeln(cad);
    end;

    (* ------------------------------------------------------------------- *)

    procedure leer_fecha(x,y : integer; var cad : string; correjir : boolean);

       (* ---------------------------------------------------------------- *)

       function poner_fecha_hoy : string;
       var y,m,d,dd : word;
           y1,m1,d1 : integer;
           y2,m2,d2 : string;
       begin
            getdate(y,m,d,dd);
            y1 := y; m1 := m; d1 := d;
            str(y1,y2); str(d1,d2);
            case m1 of
                 1 : m2 := 'Enero';
                 2 : m2 := 'Febrero';
                 3 : m2 := 'Marzo';
                 4 : m2 := 'Abril';
                 5 : m2 := 'Mayo';
                 6 : m2 := 'Junio';
                 7 : m2 := 'Julio';
                 8 : m2 := 'Agosto';
                 9 : m2 := 'Septiembre';
                10 : m2 := 'Octubre';
                11 : m2 := 'Noviembre';
                12 : m2 := 'Diciembre';
            end;
            poner_fecha_hoy :=d2+' de '+m2+' de '+y2;
       end;

       (* ---------------------------------------------------------------- *)

    begin
         gotoxy(x,y);
         textcolor(7);  
         poner_guiones(24);
         gotoxy(x,y);
         if correjir then
           begin
                borrar_resto_linea;
                poner_guiones(24);
                gotoxy(x,y);
           end;
         textcolor(white);
         readln(cad);
         gotoxy(x,y);
         if cad = '' then cad := poner_fecha_hoy;
         writeln(cad);
    end;

    (* ------------------------------------------------------------------- *)

    procedure escribir(cad : string);
    begin
         textcolor(yellow);
         write(cad);
    end;

    (* ------------------------------------------------------------------- *)

begin
     correjir := false;
     repeat
           escribir(' 1  Nombre de la Persona de Contacto : ');
           a:
           leer(41,6,nombre,correjir);
           if correjir then goto seguir;

           escribir(' 2  Nombre de la Empresa             : ');
           b:
           leer(41,7,empresa,correjir);
           if correjir then goto seguir;

           escribir(' 3  Direccin de la Empresa          : ');
           c:
           leer(41,8,direc,correjir);
           if correjir then goto seguir;

           escribir(' 4  CP - Poblacion - Provincia       : ');
           d:
           leer(41,9,cppp,correjir);
           if correjir then goto seguir;

           escribir(' 5  Fecha de envio (return=sistema)  : ');
           e:
           leer_fecha(41,10,fecha,correjir);
           if correjir then goto seguir;

           escribir(' 6 - Medio 1-CE,2-MUNDO,3-PAIS,4-DEIA : ');
           f:
           leer_periodico(41,11,periodico,correjir);
           lper := length(periodico);
           lper := 17 - lper;
           
           correjir := true;
           textcolor(lightred);
           writeln;
           writeln(' Si ha escrito bien todos los datos pulse "S" ');
           writeln(' sin pulse el numero del dato que desea correjir. ');

           seguir:
           gotoxy(1,15);
           write(' ');
           clreol;
           textcolor(white);
           z := readkey;
           write(z);
           textcolor(lightred);
           case z of
              '1' : goto a;
              '2' : goto b;
              '3' : goto c;
              '4' : goto d;
              '5' : goto e;
              '6' : goto f;
              else
                  if (z <> 'S') and (z <> 's') then goto seguir;
           end;
           writeln;
     until (z = 'S') or (z = 's');
end;

(* ----------------------------------------------------------------------- *)

procedure preparar_impresora;
var z : char;
begin
     textcolor(lightred);
     writeln;
     writeln(' Prepare la impresora y pulse una tecla para comenzar la impresin. ');
     writeln(' Si lo desea pulse la tecla "C" para cancelar la impresin. ');
     write(' ');
     textcolor(white);
     z := readkey;
     writeln(z); 
     textcolor(lightcyan);
     writeln;
     if (z = 'C') or (z = 'c') then
       begin
            writeln(' Impresion cancelada....... Volviendo al DOS. ');
            textcolor(7); 
            halt;
       end;
     write(' Imprimiendo... ');
end;

(* ----------------------------------------------------------------------- *)

procedure escribir_carta;
var nespacios : integer;
    cad       : string;

    (* ------------------------------------------------------------------- *)

    procedure poner_espacios(nsp : integer);
    var n : integer;
    begin
         for n := 1 to nsp do write(lst,' ');
    end;

    (* ------------------------------------------------------------------ *)

    function mas_grande(n1,n2,n3,n4,n5 : integer) : integer;
    var aux : integer;
    begin
         if n1 > n2 then aux := n1 else aux := n2;
         if n3 > aux then aux := n3;
         if n4 > aux then aux := n4;
         if n5 > aux then aux := n5;
         mas_grande := aux;
    end;

    (* ------------------------------------------------------------------ *)

    procedure lstln(num : integer);
    var n : integer;
    begin
         for n := 1 to num do writeln(lst);
    end;

    (* ------------------------------------------------------------------- *)

    procedure imprime(cad : string; esp : integer);
    var n,aux,l : integer;
    begin
         aux := 0;
         n   := 1;
         l   := length(cad);
         repeat
               n := n + 1;
               write(lst,cad[n]);
               if cad[n] = '"' then aux := aux + 1;
         until aux = 2;
         n := n + 1;
         for aux := n to l do
            begin
                 if (cad[aux] = ' ') and (esp > 0) then
                   begin
                        if esp > 10 then 
                          begin
                               write(lst,'   ');
                               esp := esp - 1;
                          end 
                        else
                          begin 
                               write(lst,'  ');
                               esp := esp - 1;
                          end; 
                   end
                 else write(lst,cad[aux]);
            end;
         writeln(lst);
    end;

    (* ------------------------------------------------------------------- *)

begin
     nespacios := 79 - 31 - mas_grande(length(nombre),
                                       length(empresa),
                                       length(direc),
                                       length(cppp),
                                       length(fecha));
     lstln(1);
     write(lst,'     MARIA DEL MAR GALINDO RUIZ');
     poner_espacios(nespacios);
     writeln(lst,nombre);
     write(lst,'     Licenciada en Derecho     ');
     poner_espacios(nespacios);
     writeln(lst,empresa);
     write(lst,'     Ald. Recalde 63 3D        ');
     poner_espacios(nespacios);
     writeln(lst,direc);
     write(lst,'     48012 - BILBAO            ');
     poner_espacios(nespacios);
     writeln(lst,cppp);
     writeln(lst,'     Telf: 94-4446185          ');
     lstln(5);
     writeln(lst,'                                          Bilbao ',fecha);
     lstln(4);
     writeln(lst,'                     Muy Sres mios: ');
     lstln(2);
     writeln(lst,'                    En  respuesta al articulo  aparecido  en  el  diario');
     cad := '     "'+periodico+'"  en la Guia de Empresas que ofrecen trabajo, me';
     imprime(cad,lper);
     writeln(lst,'     es grato manifestar  mi interes  en  formar parte de su equipo para');
     writeln(lst,'     la ampliacion que aqu vino anunciada.');
     lstln(1);
     writeln(lst,'                    Como  pueden  comprobar  por  el  adjunto curriculum');
     writeln(lst,'     Vitae  tengo  estudios  superiores,  conocimientos de informtica a');
     writeln(lst,'     nivel de usuario y alta capacidad de comunicacion y aprendizaje.   ');
     lstln(1);
     writeln(lst,'                    Deseo tomar parte en un proceso de seleccin, por lo');
     writeln(lst,'     que  agradecera  que  se  tuviera  en  cuenta  mi  candidatura.   ');
     writeln(lst,'     Especialmente me agradaria  poder  mantener una entrevista con Vds.');
     writeln(lst,'     para ampliar verbalmente mi curriculum.                            ');
     lstln(6);
     writeln(lst,'               A la espera de sus noticias, reciban un cordial saludo.  ');
     lstln(7);
     writeln(lst,'         Adjunto: Curriculum Vitae.');
end;

(* ----------------------------------------------------------------------- *)

procedure fin;
begin
     writeln('Impresin finalizada. ');
     textcolor(7);
     halt;
end;

(* ----------------------------------------------------------------------- *)

BEGIN

     inicializacion;
     presentacion;
     pedir_datos;
     preparar_impresora;
     escribir_carta;
     fin;

END.