program control_de_inventario(input,output);

uses crt;

type elemento = (estereo,tv);
     estilo = (portatil,fijo);
     nombre = packed array [1..80] of char;
     inventario = record
                   stockno : 1..20000;
                   proveedor : nombre;
                   cantidad : integer;
                   case tipodeitem : elemento of
                       estereo : (potencia : 1..1000);
                           tv : (tamanotubo: 1..25;
                                 color : char;
                                 case tamano : estilo of
                                     portatil : (peso : 1..100;
                                                 voltaje : 1..220);
                                     fijo : ())
                  end;

var itemenstock,reposicion : array [1..100] of inventario;
    designador : char;
    i,n,cambio : integer;

procedure leerdatos;
var contar : 1..80;
begin
     with itemenstock[i] do
         begin
              writeln;
              write('Numero de stock: ');
              readln(stockno);
              if stockno > 0 then
                begin
                     write('Tipo de elemento (e/t): ');
                     readln(designador);
                     if (designador = 'e') or (designador = 'E') then
                       begin
                            tipodeitem := estereo;
                            write('Nivel de potencia: ');
                            readln(potencia)
                       end
                     else
                       begin
                            tipodeitem := tv;
                            write('TV portatil? (s/n) ');
                            readln(designador);
                            if (designador = 's') or (designador = 'S') then
                              begin
                                   tamano := portatil;
                                   write('Peso: ');
                                   readln(peso);
                                   write('Voltaje: ');
                                   readln(voltaje)
                              end
                            else tamano := fijo;
                            write('Tamao del tubo: ');
                            readln(tamanotubo);
                            write('Color: (s/n) ');
                            readln(color)
                       end;
                     write('Proveedor: ');
                     contar := 1;
                     repeat
                           read(proveedor[contar]);
                           contar := succ(contar)
                     until eoln;
                     write('Nivel inicial de inventario: ');
                     readln(cantidad);
                     write('Cambio en el nivel de inventario: ');
                     readln(cambio);
                     cantidad := cantidad + cambio;
                     if cantidad < 0 then
                       begin
                            reposicion[i] := itemenstock[i];
                            reposicion[i].cantidad := abs(cantidad);
                            cantidad := 0
                       end
                end
         end
end;

procedure escribirresultado;
begin
     clrscr;
     writeln;
     writeln;
     writeln('            S I S T E M A  D E  C O N T R O L  D E  I N V E N T A R I O ');
     writeln;
     writeln('                        I N V E N T A R I O  A C T U A L ');
     writeln;
     for i := 1 to n do
        with itemenstock[i] do
           begin
                writeln;
                writeln('Num. de stock: ',stockno:5);
                case tipodeitem of
                  estereo : writeln('Estero: ',potencia:4,' vatios');
                       tv : begin
                                 if tamano = portatil then writeln('Portatil ');
                                 if (color = 's') or (color = 'S') then writeln('TV en color ')
                                   else writeln('TV en B y N');
                                 writeln('Tubo de ',tamanotubo:2,'-pulgadas');
                                 if tamano = portatil then
                                   begin
                                        writeln('Peso: ',peso:3,' libras      ');
                                        writeln('Voltaje: ',voltaje:3,' voltios');
                                   end
                            end
                end;
                writeln('Proveedor: ',proveedor);
                if cantidad > 0 then writeln('Inventario actual: ',cantidad:3)
                  else writeln('Cantidad a reponer: ',reposicion[i].cantidad:3);
                writeln
           end
end;

BEGIN

clrscr;
writeln;
writeln;
writeln('           S I S T E M A  D E  C O N T R O L  D E  I N V E N T A R I O ');
writeln;
writeln('                    E N T R A D A  D E  D A T O S ');
writeln;
writeln('  Cuanto termine, introduzca 0 para el numero de stock');
writeln;
i := 0;
repeat
      i := succ(i);
      leerdatos;
until itemenstock[i].stockno = 0;
n := pred(i);
if n > 0 then escribirresultado
end.
