program loteria(input,output,f,f1);

uses crt,drivers;

type regs = record
           n1,n2,n3,n4,n5,n6 : integer;
           c : integer
          end;

var f,f1 : file of regs;
    tab2 : array [1..6] of integer;
    reg : regs;
    tab : array [1..49] of integer;
    tipo : string[13];
    p : boolean;
    z : char;

procedure cuadro;
begin
     clrscr;
     writeln('ͻ');
     writeln('                                                                           ');
     writeln(' Este programa ha sido donado por el autor para el dominio pblico, por lo ');
     writeln(' cual su distribucin es libre y gratuita estanto totalmente libre de toda ');
     writeln(' carga econmica. El autor  no  se  responsabiliza de cualquier dao, que, ');
     writeln(' directa o indirectamente, este programa pueda causar,  bien  sea un  dao ');
     writeln(' relativo al software o al hardware.                                       ');
     writeln('                                                                           ');
     writeln(' Autor: Alvaro Canteiro Martinez.      Internet: siacamaa@sisz00.si.ehu.es ');
     writeln('                                        FidoNet: 2:344/17.25               ');
     writeln('ͼ');
     writeln;
     halt;
end;

procedure inicializar_tabla;
var n : integer;
begin
     for n := 1 to 49 do tab[n] := 0;
     for n := 1 to 6 do tab2[n] := 0
end;

procedure leer_numeros;
var n : integer;
begin
     reset(f);
     while not eof(f) do
          begin
               read(f,reg);
               with reg do
                   begin
                        for n := 1 to 49 do
                           begin
                                if (n1 = n) or (n2 = n) or (n3 = n) or
                                   (n4 = n) or (n5 = n) or (n6 = n) or
                                   (c = n) then tab[n] := tab[n] + 1
                           end
                   end
          end;
     close(f)
end;

procedure memorizar_numeros;
begin
     assign(f1,'bak.');
     reset(f);
     rewrite(f1);
     while not eof(f) do
          begin
               read(f,reg);
               write(f1,reg)
          end;
     repeat
           clrscr;
           writeln;
           writeln;
           writeln;
           writeln(' Teclee 0 como primer numero para acabar');
           writeln;
           writeln;
           writeln;
           write(' Primer nmero  = '); readln(reg.n1);
           if reg.n1 <> 0 then
             begin
                  with reg do
                      begin
                           write(' Segundo nmero = '); readln(n2);
                           write(' Tercer nmero  = '); readln(n3);
                           write(' Cuarto nmero  = '); readln(n4);
                           write(' Quinto nmero  = '); readln(n5);
                           write(' Sexto nmero   = '); readln(n6);
                           write(' Complementario = '); readln(c)
                      end
             end;
           if reg.n1 <> 0 then write(f1,reg);
     until reg.n1 = 0;
     close(f);
     close(f1);
     erase(f);
     rename(f1,tipo)
end;

procedure elegir_tipo;
begin
     tipo := ' ';
     z := ' ';
     clrscr;
     gotoxy(13,13);
     write(' Pulse "B" para Bonoloto o "P" para Loteria Primitiva');
     while not ((z = 'B') or (z = 'b') or (z = 'P') or (z = 'p')) do z := readkey;
     if (z = 'B') or (z = 'b') then tipo := 'BONOLOTO.DAT';
     if (z = 'P') or (z = 'p') then tipo := 'PRIMI.DAT';
     assign(f,tipo)
end;

procedure pausa;
begin
     write(' Pulse una tecla para continuar ');
     z := readkey
end;

procedure jugada_aleatoria;
var n,x : integer;
begin
     clrscr;
     writeln;
     writeln('                  ͻ');
     writeln('                   J U G A D A  A L E A T O R I A ');
     writeln('                  ͼ');
     writeln;
     for n := 1 to 6 do
        begin
             x := random(49) + 1;
             writeln(' Numero ',n,' = ',x)
        end;
     writeln;
     writeln;
     pausa
end;

function regla3(nreg,x : integer) : real;
var n : real;
begin
     regla3 := (x*80) / nreg
end;

function contar_registros : integer;
var c : integer;
begin
     reset(f);
     c := 0;
     while not eof(f) do
          begin
               read(f,reg);
               c := c + 1
          end;
     contar_registros := c
end;

procedure jugada_datos;
var n,nreg,p,t,aux,auxp,m : integer;
begin
     clrscr;
     inicializar_tabla;
     leer_numeros;
     for n := 1 to 20 do
        begin
             gotoxy(5,n+2);
             write('Numero ',n,' = ',tab[n],' veces')
        end;
     for n := 21 to 40 do
        begin
             gotoxy(30,n-18);
             write('Numero ',n,' = ',tab[n],' veces')
        end;
     for n := 41 to 49 do
        begin
             gotoxy(55,n-38);
             write('Nmero ',n,' = ',tab[n],' veces')
        end;
     gotoxy(1,24);
     pausa;
     clrscr;
     writeln;
     writeln('                     ͻ');
     writeln('                       G R A F I C O  D E  B A R R A S ');
     writeln('                     ͼ');
     writeln;
     writeln;
     nreg := contar_registros;
     for n := 1 to 6 do
        begin
             aux := 0;
             auxp := 0;
             for m := 1 to 49 do
                begin
                     if tab[m] > aux then
                       begin
                            aux := tab[m];
                            auxp := m
                       end
                end;
             tab[auxp] := 0;
             tab2[n] := auxp;
             t := trunc(regla3(nreg,aux));
             writeln;
             write('   ');
             for p := 1 to t do write('');
             for p := t to 65 do write(' ');
             writeln('Numero ',auxp)
        end;
     writeln;
     writeln;
     writeln('   Numero de combinaciones introducidas = ',nreg);
     writeln;
     pausa;
     clrscr;
     writeln;
     writeln('              ͻ');
     writeln('               J U G A D A  U S A N D O  D A T O S ');
     writeln('              ͼ');
     writeln;
     writeln;
     for n := 1 to 6 do writeln(' Nmero ',n,' = ',tab2[n]);
     writeln;
     writeln;
     pausa
end;

procedure hacer_jugada;
var c : char;
begin
     clrscr;
     c := ' ';
     writeln;
     writeln('                        ͻ');
     writeln('                         C R E A R  J U G A D A ');
     writeln('                        ͼ');
     writeln;
     writeln;
     writeln('     0 . . . . . . . . VOLVER AL MENU ANTERIOR ');
     writeln;
     writeln('     1 . . . . . . . . CREAR JUGADA ALEATORIA ');
     writeln;
     writeln('     2 . . . . . . . . CREAR JUGADA USANDO DATOS ');
     writeln;
     writeln;
     write('     Opcion: ');
     while not ((c = '0') or (c = '1') or (c = '2')) do c := readkey;
     if c = '0' then exit;
     if c = '1' then jugada_aleatoria;
     if c = '2' then jugada_datos;
     hacer_jugada
end;

procedure inicializar_archivo;
begin
     clrscr;
     z := ' ';
     gotoxy(20,11); write('ATENCION: TODOS LOS DATOS EN ',TIPO,' SE DESTRUIRAN');
     gotoxy(20,13); write('ESTA SEGURO? S/N  ');
     while not ((z = 'S') or (z = 's') or (z = 'N') or (z = 'n')) do z := readkey;
     if (z = 'S') or (z = 's') then
       begin
            rewrite(f);
            close(f)
       end
end;

procedure cambiar;
begin
     if tipo = 'BONOLOTO.DAT' then
       begin
            tipo := 'PRIMI.DAT';
            assign(f,tipo)
       end
     else
       begin
            tipo := 'BONOLOTO.DAT';
            assign(f,tipo)
       end
end;

procedure corregir_errores;
var nr : integer;
procedure acabar;
begin
     while not eof(f) do
          begin
               read(f,reg);
               write(f1,reg);
          end;
end;
procedure corregir(r : char);
procedure flash(a,b : integer);
begin
     gotoxy(a,b);
     write('      ');
     gotoxy(a,b)
end;
begin
     if r = '1' then
       begin
            reg.n1 := 0;
            flash(23,9);
            read(reg.n1);
       end;
     if r = '2' then
       begin
            reg.n2 := 0;
            flash(23,10);
            read(reg.n2);
       end;
     if r = '3' then
       begin
            reg.n3 := 0;
            flash(23,11);
            read(reg.n3);
       end;
     if r = '4' then
       begin
            reg.n4 := 0;
            flash(23,12);
            read(reg.n4);
       end;
     if r = '5' then
       begin
            reg.n5 := 0;
            flash(23,13);
            read(reg.n5);
       end;
     if r = '6' then
       begin
            reg.n6 := 0;
            flash(23,14);
            read(reg.n6);
       end;
     if r = '7' then
       begin
            reg.c := 0;
            flash(23,15);
            read(reg.c);
       end;
end;
begin
     nr := 0;
     clrscr;
     assign(f1,'bak.');
     reset(f);
     rewrite(f1);
     writeln;
     writeln('                     ͻ');
     writeln('                      C O R R E G I R  E R R O R E S ');
     writeln('                     ͼ');
     writeln;
     writeln;
     writeln(' Registro Nmero ');
     while (not eof(f)) and ((z <> 'A') or (z <> 'a')) do
          begin
               read(f,reg);
               nr := nr + 1;
               gotoxy(19,7);
               write(nr);
               gotoxy(1,9);
               writeln(' 1 - Primer  nmero = ',reg.n1);
               writeln(' 2 - Segundo nmero = ',reg.n2);
               writeln(' 3 - Tercer  nmero = ',reg.n3);
               writeln(' 4 - Cuarto  nmero = ',reg.n4);
               writeln(' 5 - Quinto  nmero = ',reg.n5);
               writeln(' 6 - Sexto   nmero = ',reg.n6);
               writeln(' 7 - Complementario = ',reg.c);
               repeat
                     gotoxy(1,20);
                     writeln(' Pulse "C" para ir al siguiente registro ');
                     writeln(' o nmero del 1 al 7 para corregir ');
                     write(' o "A" para acabar. ');
                     z := readkey;
                     if (z >= '1') or (z <= '7') then corregir(z);
               until ((z = 'C') or (z = 'c') or (z = 'A') or (z = 'a'));
               write(f1,reg);
               if (z = 'a') or (z = 'A') then acabar;
          end;
     close(f);
     close(f1);
     erase(f);
     rename(f1,tipo);
end;

procedure mono;
begin
     textcolor(7);
     textbackground(0);
     clrscr
end;

procedure color;
begin
     textcolor(14);
     textbackground(1);
     clrscr
end;

procedure mono_color;
begin
     clrscr;
     gotoxy(20,13);
     write('Monitor Monocromo o Color (M o C)   ');
     repeat
           z := readkey;
     until (z = 'M') or (z = 'm') or (z = 'C') or (z = 'c');
     if (z = 'M') or (z = 'm') then mono else color
end;

procedure fin;
begin
     mono;
     cuadro;
end;

BEGIN

     initsyserror;
     mono_color;
     z := ' ';
     elegir_tipo;
     repeat
           clrscr;
           z := ' ';
           gotoxy(60,23);
           write('Versin 1.0');
           gotoxy(1,1);
           writeln;
           if tipo = 'BONOLOTO.DAT' then
             begin
                  writeln('                           ͻ');
                  writeln('                            B  O  N  O  L  O  T  O ');
                  writeln('                           ͼ')
             end
           else
             begin
                  writeln('                       ͻ');
                  writeln('                        L O T E R I A  P R I M I T I V A ');
                  writeln('                       ͼ')
             end;
           writeln;
           writeln;
           writeln('     0 . . . . . . . . VOLVER AL DOS ');
           writeln;
           writeln('     1 . . . . . . . . MEMORIZAR NUMEROS ');
           writeln;
           writeln('     2 . . . . . . . . MOSTRAR JUGADA ');
           writeln;
           writeln('     3 . . . . . . . . INICIALIZAR ARCHIVO DE DATOS ');
           writeln;
           writeln('     4 . . . . . . . . CORREGIR ERRORES ');
           writeln;
           writeln('     5 . . . . . . . . CAMBIAR TIPO DE LOTERIA ');
           writeln;
           writeln;
           write('     Opcin: ');
           while not ((z = '0') or (z = '1') or (z = '2') or (z = '3') or (z = '4') or (z = '5')) do z := readkey;
           if z = '1' then memorizar_numeros;
           if z = '2' then hacer_jugada;
           if z = '3' then inicializar_archivo;
           if z = '4' then corregir_errores;
           if z = '5' then cambiar
     until z = '0';
     fin

END.
