program paquete_de_matematicas(input,output,fichero);

uses crt,printer,drivers;

var z:char;

(****************************************************************************)
(*                        PORTADA DEL PROGRAMA                              *)
(****************************************************************************)

procedure portada;
var c,cuad : integer;
begin
     for c:=1 to 12 do
        begin
             gotoxy(c,c);
             for cuad:=c to 80-c do write('');
             for cuad:=c+1 to 25-c do
                begin
                     gotoxy(c,cuad);  write('');
                     gotoxy(80-c,cuad); write('')
                end;
             gotoxy(c,26-c);
             for cuad:=c to 80-c do write('');
             delay(100)
         end;
     gotoxy(13,13);
     writeln('  PAQUETE DE MATEMATICAS - V 1.0  ');
     z:=readkey
end;

procedure cuadro;
begin
     clrscr;
     writeln('ͻ');
     writeln('                                                                           ');
     writeln(' Este programa ha sido donado por el autor para el dominio pblico, por lo ');
     writeln(' cual su distribucin es libre y gratuita estanto totalmente libre de toda ');
     writeln(' carga econmica. El autor  no  se  responsabiliza de cualquier dao, que, ');
     writeln(' directa o indirectamente, este programa pueda causar,  bien  sea un  dao ');
     writeln(' relativo al software o al hardware.                                       ');
     writeln('                                                                           ');
     writeln(' Autor: Alvaro Canteiro Martinez.      Internet: siacamaa@sisz00.si.ehu.es ');
     writeln('                                        FidoNet: 2:344/17.25               ');
     writeln('ͼ');
     writeln;
     halt;
end;

(*****************************************************************************)
(*                   RESOLUCION DE ECUACIONES                                *)
(*****************************************************************************)

var matriz,matrizx,matrizy,matrizz,matrizt,matrizp    : real;
    matriz1,matriz2,matriz3,dmatriz                   : real;
    solx,soly,solz,solt,solp                          : real;
    d1,d2,d3,d4,d5,d6,d7,d8,d9,dprin                  : real;
    tot1,tot2,tot3,totx,toty,totz,tott,totp           : real;
    de1,de2,de3,de4,de5,de6,de7,de8                   : real;
    de9,de10,de11,de12,de13,de14,de15,de16            : real;
    x1,y1,z1,t1,p1,k1                                 : real;
    x2,y2,z2,t2,p2,k2                                 : real;
    x3,y3,z3,t3,p3,k3                                 : real;
    x4,y4,z4,t4,p4,k4                                 : real;
    x5,y5,z5,t5,p5,k5                                 : real;
    opcion,opcio                                      : integer;

label inicio,fin;

(*        ECUACIONES DE SEGUNDO GRADO          *)
(*        ===========================          *)

procedure ecuaciones1;
var ter1,ter2,ter3,raiz : real;
begin
     clrscr;
     writeln;
     writeln('                        ͻ');
     writeln('                          ECUACIONES DE SEGUNDO GRADO  ');
     writeln('                        ͼ');
     writeln;
     writeln(' Introduce los coeficientes');
     writeln;

     (*introduccion de datos*)

     write(' X = ');    read(ter1);
     write(' X  = ');    read(ter2);
     write(' N  = ');    read(ter3);
     writeln;

     (*resolucion de sistema*)

     raiz:= ((ter2*ter2) - ( 4 * ter1 * ter3 ) );
     if raiz <= 0 then
       begin
            dmatriz:=0;
            raiz:=-raiz
       end;
     solx:= (- ter2 + sqrt(raiz)) / (2 * ter1);
     soly:= (- ter2 - sqrt(raiz)) / (2 * ter1);

     (*impresion de soluciones*)

     if dmatriz <> 0 then
       begin
            writeln(' SOLUCION 1 = ',solx:7:5);
            writeln(' SOLUCION 2 = ',soly:7:5);
            writeln; writeln; write(' Pulse una tecla para continuar ');
            z:=readkey
       end;
     if dmatriz = 0 then
       begin
            writeln(' No hay solucion para la ecuacion');
            writeln; write(' Pulse una tecla para continuar ');
            z:=readkey
       end
end;

(*          SISTEMAS DE DOS ECUACIONES CON DOS INCOGNITAS          *)
(*          =============================================          *)

procedure portada2;
begin
     clrscr;
     writeln;
     writeln('                ͻ');
     writeln('                  SISTEMA DE DOS ECUACIONES CON DOS INCOGNITAS  ');
     writeln('                ͼ');
     writeln
end;

procedure ecuaciones2;
begin
     portada2;
     writeln(' Introduce los coeficientes');
     writeln;

     (*introduccion de datos*)

     write(' X1 = ');    read(x1);
     write(' Y1 = ');    read(y1);
     write(' K1 = ');    read(k1);
     writeln;
     write(' X2 = ');    read(x2);
     write(' Y2 = ');    read(y2);
     write(' K2 = ');    read(k2);
     writeln;

     (*resolucion de sistema*)

     matriz := (x1 * y2) - (y1 * x2);
     if matriz = 0 then
       begin
            dmatriz:=0;
            matriz:=1
       end;
     solx := ((k1 * y2) - (y1 * k2)) / matriz;
     soly := ((x1 * k2) - (k1 * x2)) / matriz;

     (*impresion de soluciones*)

     portada2;

     if dmatriz <> 0 then
        begin
             writeln(' X = ',solx:4:2);
             writeln(' Y = ',soly:4:2);
             writeln; writeln; write(' Pulse una tecla para continuar ');
             z:=readkey
        end;
     if dmatriz = 0 then
       begin
            writeln(' No existe solucion para el sistema');
            writeln;  write(' Pulse una tecla para continuar ');
            z:=readkey
       end;
end;

(*          SISTEMAS DE 3 ECUACIONES CON 3 INCOGNITAS          *)
(*          =========================================          *)

procedure portada3;
begin
     clrscr;
     writeln;
     writeln('             ͻ');
     writeln('               SISTEMA DE TRES ECUACIONES CON TRES INCOGNITAS  ');
     writeln('             ͼ');
     writeln
end;

procedure ecuaciones3;
begin
     portada3;
     writeln(' Introduce los coeficientes');
     writeln;

     (*introduccion de datos*)

     write(' X1 = ');    read(x1);
     write(' Y1 = ');    read(y1);
     write(' Z1 = ');    read(z1);
     write(' K1 = ');    read(k1);
     writeln;
     write(' X2 = ');    read(x2);
     write(' Y2 = ');    read(y2);
     write(' Z2 = ');    read(z2);
     write(' K2 = ');    read(k2);
     writeln;
     write(' X3 = ');    read(x3);
     write(' Y3 = ');    read(y3);
     write(' Z3 = ');    read(z3);
     write(' K3 = ');    read(k3);
     writeln;

     (*resolucion de sistema*)

     matriz1:=(y2*z3)-(z2*y3);
     matriz2:=(x2*z3)-(z2*x3);
     matriz3:=(x2*y3)-(y2*x3);
     matriz:=(x1*matriz1) -(y1*matriz2) + (z1*matriz3);

     if matriz = 0 then
       begin
            dmatriz:=0;
            matriz:=1
       end;

     matrizx:=k1*(y2*z3-z2*y3) - y1*(k2*z3-z2*k3) + z1*(k2*y3-y2*k3);
     matrizy:=x1*(k2*z3-z2*k3) - k1*(x2*z3-z2*x3) + z1*(x2*k3-k2*x3);
     matrizz:=x1*(y2*k3-k2*y3) - y1*(x2*k3-k2*x3) + k1*(x2*y3-y2*x3);

     solx:=matrizx/matriz;
     soly:=matrizy/matriz;
     solz:=matrizz/matriz;

     (*impresion de soluciones*)

     portada3;

     if dmatriz <> 0 then
       begin
            writeln(' X = ',solx:4:2);
            writeln(' Y = ',soly:4:2);
            writeln(' Z = ',solz:4:2);
            writeln; writeln; write(' Pulse una tecla para continuar ');
            z:=readkey
       end;
     if dmatriz = 0 then
       begin
            writeln(' No existe solucion para el sistema');
            writeln; writeln(' Pulse una tecla para continuar ');
            z:=readkey
       end
end;

(*          SISTEMAS DE 4 ECUACIONES CON 4 INCOGNITAS          *)
(*          =========================================          *)

function det3x3 (d1,d2,d3,d4,d5,d6,d7,d8,d9 : real) : real;
begin
     tot1 := d1 * (d5*d9 - d6*d8);
     tot2 := d2 * (d4*d9 - d6*d7);
     tot3 := d3 * (d4*d8 - d5*d7);
     det3x3 := tot1 - tot2 + tot3
end;

function det4x4(de1,de2,de3,de4,de5,de6,de7,de8,de9,de10,de11,de12,de13,
                   de14,de15,de16 : real) : real;
begin
     totx:=de1*det3x3(de6,de7,de8,de10,de11,de12,de14,de15,de16);
     toty:=de2*det3x3(de5,de7,de8,de9,de11,de12,de13,de15,de16);
     totz:=de3*det3x3(de5,de6,de8,de9,de10,de12,de13,de14,de16);
     tott:=de4*det3x3(de5,de6,de7,de9,de10,de11,de13,de14,de15);
     det4x4 := totx - toty + totz - tott
end;

function det5x5(f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f11,f12,f13,f14,f15,f16,f17,
                f18,f19,f20,f21,f22,f23,f24,f25 : real) : real;
begin
     totx := f1*det4x4(f7,f8,f9,f10,f12,f13,f14,f15,f17,f18,f19,f20,f22,f23,f24,f25);
     toty := f2*det4x4(f6,f8,f9,f10,f11,f13,f14,f15,f16,f18,f19,f20,f21,f23,f24,f25);
     totz := f3*det4x4(f6,f7,f9,f10,f11,f12,f14,f15,f16,f17,f19,f20,f21,f22,f24,f25);
     tott := f4*det4x4(f6,f7,f8,f10,f11,f12,f13,f15,f16,f17,f18,f20,f21,f22,f23,f25);
     totp := f5*det4x4(f6,f7,f8,f9,f11,f12,f13,f14,f16,f17,f18,f19,f21,f22,f23,f24);
     det5x5 := totx - toty + totz -tott + totp
end;

procedure portada4;
begin
     clrscr;
     writeln;
     writeln('               ͻ');
     writeln('                 SISTEMA DE CUATRO ECUACIONES CON CUATRO INCOGNITAS  ');
     writeln('               ͼ');
     writeln
end;

procedure ecuaciones4;
begin
     portada4;
     writeln(' Introduce los coeficientes');
     writeln;

     (* introduccion de coeficientes *)

     write(' X1 = ');    read(x1);
     write(' Y1 = ');    read(y1);
     write(' Z1 = ');    read(z1);
     write(' T1 = ');    read(t1);
     write(' K1 = ');    read(k1);
     writeln;
     write(' X2 = ');    read(x2);
     write(' Y2 = ');    read(y2);
     write(' Z2 = ');    read(z2);
     write(' T2 = ');    read(t2);
     write(' K2 = ');    read(k2);

     gotoxy(41,8); write(' X3 = ');     read(x3);
     gotoxy(41,9); write(' Y3 = ');     read(y3);
     gotoxy(41,10); write(' Z3 = ');    read(z3);
     gotoxy(41,11); write(' T3 = ');    read(t3);
     gotoxy(41,12); write(' K3 = ');    read(k3);

     gotoxy(41,14); write(' X4 = ');    read(x4);
     gotoxy(41,15); write(' Y4 = ');    read(y4);
     gotoxy(41,16); write(' Z4 = ');    read(z4);
     gotoxy(41,17); write(' T4 = ');    read(t4);
     gotoxy(41,18); write(' K4 = ');    read(k4);

     (* calculo del determinante de la matriz principal *)

     dprin:=det4x4(x1,y1,z1,t1,x2,y2,z2,t2,x3,y3,z3,t3,x4,y4,z4,t4);
     if dprin = 0 then
       begin
            dmatriz:=0;
            dprin:=1
       end;

     (* calculo del determinante de las matrizes x y z t *)

     matrizx:=det4x4(k1,y1,z1,t1,k2,y2,z2,t2,k3,y3,z3,t3,k4,y4,z4,t4);
     matrizy:=det4x4(x1,k1,z1,t1,x2,k2,z2,t2,x3,k3,z3,t3,x4,k4,z4,t4);
     matrizz:=det4x4(x1,y1,k1,t1,x2,y2,k2,t2,x3,y3,k3,t3,x4,y4,k4,t4);
     matrizt:=det4x4(x1,y1,z1,k1,x2,y2,z2,k2,x3,y3,z3,k3,x4,y4,z4,k4);

     (* calculo de las soluciones x y z t *)

     solx := matrizx/dprin;
     soly := matrizy/dprin;
     solz := matrizz/dprin;
     solt := matrizt/dprin;

     (* impresion de las soluciones x y z t *)

     portada4;

     if dmatriz <> 0 then
       begin
            writeln(' X = ',solx:4:2);
            writeln(' Y = ',soly:4:2);
            writeln(' Z = ',solz:4:2);
            writeln(' T = ',solt:4:2);
            writeln;
            writeln
       end
     else
       begin
            writeln(' No existe solucion para el sistema');
            writeln
       end;
     write(' Pulse una tecla para continuar ');
     z := readkey
end;

procedure portada5;
begin
     clrscr;
     writeln;
     writeln('               ͻ');
     writeln('                 SISTEMA DE CINCO ECUACIONES CON CINCO INCOGNITAS ');
     writeln('               ͼ');
     writeln
end;

procedure ecuaciones5;
begin
     portada5;
     writeln(' Introduce coeficientes: ');
     writeln;
     write(' X1 = '); readln(x1);
     write(' Y1 = '); readln(y1);
     write(' Z1 = '); readln(z1);
     write(' T1 = '); readln(t1);
     write(' P1 = '); readln(p1);
     write(' K1 = '); readln(k1);
     writeln;
     write(' X2 = '); readln(x2);
     write(' Y2 = '); readln(y2);
     write(' Z2 = '); readln(z2);
     write(' T2 = '); readln(t2);
     write(' P2 = '); readln(p2);
     write(' K2 = '); readln(k2);

     gotoxy(26,8);  write(' X3 = '); readln(x3);
     gotoxy(26,9);  write(' Y3 = '); readln(y3);
     gotoxy(26,10); write(' Z3 = '); readln(z3);
     gotoxy(26,11); write(' T3 = '); readln(t3);
     gotoxy(26,12); write(' P3 = '); readln(p3);
     gotoxy(26,13); write(' K3 = '); readln(k3);

     gotoxy(26,15); write(' X4 = '); readln(x4);
     gotoxy(26,16); write(' Y4 = '); readln(y4);
     gotoxy(26,17); write(' Z4 = '); readln(z4);
     gotoxy(26,18); write(' T4 = '); readln(t4);
     gotoxy(26,19); write(' P4 = '); readln(p4);
     gotoxy(26,20); write(' K4 = '); readln(k4);

     gotoxy(52,8);  write(' X5 = '); readln(x5);
     gotoxy(52,9);  write(' Y5 = '); readln(y5);
     gotoxy(52,10); write(' Z5 = '); readln(z5);
     gotoxy(52,11); write(' T5 = '); readln(t5);
     gotoxy(52,12); write(' P5 = '); readln(p5);
     gotoxy(52,13); write(' K5 = '); readln(k5);

     (* calculo del determinante de la matriz principal *)

     dprin := det5x5(x1,y1,z1,t1,p1,x2,y2,z2,t2,p2,x3,y3,z3,t3,p3,x4,y4,z4,t4,p4,x5,y5,z5,t5,p5);

     if dprin = 0 then
       begin
            dmatriz := 0;
            dprin := 1
       end;

     (* calculo del determinante de las matrizes x y z t p *);

     matrizx := det5x5(k1,y1,z1,t1,p1,k2,y2,z2,t2,p2,k3,y3,z3,t3,p3,k4,y4,z4,t4,p4,k5,y5,z5,t5,p5);
     matrizy := det5x5(x1,k1,z1,t1,p1,x2,k2,z2,t2,p2,x3,k3,z3,t3,p3,x4,k4,z4,t4,p4,x5,k5,z5,t5,p5);
     matrizz := det5x5(x1,y1,k1,t1,p1,x2,y2,k2,t2,p2,x3,y3,k3,t3,p3,x4,y4,k4,t4,p4,x5,y5,k5,t5,p5);
     matrizt := det5x5(x1,y1,z1,k1,p1,x2,y2,z2,k2,p2,x3,y3,z3,k3,p3,x4,y4,z4,k4,p4,x5,y5,z5,k5,p5);
     matrizp := det5x5(x1,y1,z1,t1,k1,x2,y2,z2,t2,k2,x3,y3,z3,t3,k3,x4,y4,z4,t4,k4,x5,y5,z5,t5,k5);

     (* calculo de las soluciones x y z t p *)

     solx := matrizx/dprin;
     soly := matrizy/dprin;
     solz := matrizz/dprin;
     solt := matrizt/dprin;
     solp := matrizp/dprin;

     portada5;

     (* impresion de las soluciones *)

     if dmatriz <> 0 then
       begin
            writeln(' X = ',solx:4:2);
            writeln(' Y = ',soly:4:2);
            writeln(' Z = ',solz:4:2);
            writeln(' T = ',solt:4:2);
            writeln(' P = ',solp:4:2);
            writeln;
            writeln
       end
     else
       begin
            writeln; writeln;
            writeln(' No existe solucion para el sistema ');
            writeln
       end;
     write(' Pulse una tecla para continuar ');
     z := readkey
end;

(*****************************************************************************)
(*                    PROCEDIMIENTO CONTROLADOR DE ECUACIONES                *)
(*****************************************************************************)

procedure ecuaciones;
begin
       clrscr;
       opcion:=47;
       writeln;
       writeln('                    ͻ');
       writeln('                      RESULUCION DE ECUACIONES  ');
       writeln('                    ͼ');
       writeln;
       writeln(' 0................VOLVER AL MENU PRINCIPAL');
       writeln;
       writeln(' 1................ECUACIONES DE SEGUNDO GRADO');
       writeln;
       writeln(' 2................DOS ECUACIONES CON DOS INCOGNITAS');
       writeln;
       writeln(' 3................TRES ECUACIONES CON TRES INCOGNITAS');
       writeln;
       writeln(' 4................CUATRO ECUACIONES CON CUATRO INCOGNITAS');
       writeln;
       writeln(' 5................CINCO ECUACIONES CON CINCO INCOGNITAS');
       writeln;
       write(' Opcin: ');
       readln(opcio);
       clrscr;
       if opcio = 1 then ecuaciones1;
       if opcio = 2 then ecuaciones2;
       if opcio = 3 then ecuaciones3;
       if opcio = 4 then ecuaciones4;
       if opcio = 5 then ecuaciones5;
       if opcio = 0 then exit;
       ecuaciones
end;

(*****************************************************************************)
(*                      RAZONES TRIGONOMETRICAS                              *)
(*****************************************************************************)

procedure razones;
var grados,minutos,segundos              :integer;
    angulorad,angulo,seno,coseno,tangente:real;
    secante,cosecante,cotangente         :real;
    decimales                            :integer;
    tangen,secan,cosecan,cotangen        :char;
begin
     z:='s';
     while (z = 's') or (z = 'S') do
     begin
          clrscr;
          tangen:=' ';
          secan:=' ';
          cosecan:=' ';
          cotangen:=' ';

          (* introduccion de datos *)

          writeln('                    ͻ');
          writeln('                      RAZONES TRIGONOMETRICAS  ');
          writeln('                    ͼ');
          writeln;
          writeln;
          writeln(' Dime el angulo cuyas razones quieres saber: ');
          write(' Grados: ');
          readln(grados);
          write(' Minutos: ');
          readln(minutos);
          write(' Segundos: ');
          readln(segundos);
          write(' Con cuantos decimales quieres los resultados: ');
          readln(decimales);
          writeln;
          writeln;

          (* calculo de las razones trigonometricas *)

          angulorad := grados + minutos/60 + segundos/3600;
          angulo:=pi*(angulorad)/180;
          seno:=sin(angulo);
          coseno:=cos(angulo);
          if coseno = 0 then tangen:='' else tangente:=seno/coseno;
          if coseno = 0 then secan:='' else secante:=1/coseno;
          if seno = 0 then cosecan:='' else cosecante:=1/seno;
          if tangente = 0 then cotangen:='' else cotangente:=1/tangente;

          (* impresion de resultados *)

          writeln(' ANGULO:      ',grados,'',minutos,'',segundos,'');
          writeln;
          writeln(' SENO:        ',seno:decimales+2:decimales);
          writeln(' COSENO:      ',coseno:decimales+2:decimales);
          if tangen='' then writeln(' TANGENTE:    ',tangen)
            else writeln(' TANGENTE:    ',tangente:decimales+2:decimales);
          if secan='' then writeln(' SECANTE:     ',secan)
            else writeln(' SECANTE:     ',secante:decimales+2:decimales);
          if cosecan='' then writeln(' COSECANTE:   ',cosecan)
            else writeln(' COSECANTE:   ',cosecante:decimales+2:decimales);
          if cotangen='' then writeln(' COTANGENTE:  ',cotangen)
            else writeln(' COTANGENTE:  ',cotangente:decimales+2:decimales);
          writeln;
          writeln;
          writeln;
          write(' Quieres seguir con esta utilidad: S/N  ');
          z:=readkey
     end
end;

(*****************************************************************************)
(*                    CALCULO DE PROBABILIDADES                              *)
(*****************************************************************************)

procedure calculo;
type tabla = array [1..500] of integer;
var num,numfinal,numaleatorio,suma,nume,numero:integer;
    nu : tabla;
begin
     z:='s';
     while (z = 's') or (z = 'S') do
     begin
          clrscr;
          numfinal:=0;
          numaleatorio:=0;

          (* introduccion de datos*)

          writeln('                        ͻ');
          writeln('                          CALCULO DE PROBABILIDADES  ');
          writeln('                        ͼ');
          writeln;
          writeln;

          writeln(' EL INTERVALO VA A SER DESDE 1 HASTA MAXIMO DE 500');
          write(' Numero:  ');
          readln(numfinal);
          if numfinal >= 500 then
            begin
                 writeln(' El intervalo maximo es [1..500]');
                 writeln(' El numero introducido, ha sido reducido a 500');
                 numfinal := 500
            end;
          writeln(' SOBRE CUANTOS NUMEROS ALEATORIOS QUIERES QUE SE HAGA LA MUESTRA');
          writeln(' EL MAXIMO ES DE 32400');
          write(' Numero: ');
          readln(numaleatorio);

          (* calculo de numeros *)

          for nume:=1 to numfinal do nu[nume]:=0;

          clrscr;
          gotoxy(15,15);
          write('REALIZANDO CALCULO DE PROBABILIDADES     ');

          for nume:=1 to numaleatorio do
             begin
                  numero:=random(numfinal)+1;
                  nu[numero]:=nu[numero]+1;
                  gotoxy(57,15);
                  write(nume)
             end;

          (* impresion de resultados *)

          clrscr;
          gotoxy(10,15);
          write('Introduce P si quieres el resultado por impresora ');
          z:=readkey;
          clrscr;
          if z = 'P' then
            begin
                 writeln(lst);
                 writeln(lst,' CALCULO DE ',numaleatorio:4,' NUMEROS ENTRE EL 1 Y EL ', numfinal);
                 writeln(lst);
                 for num:=1 to numfinal do
                    begin
                         writeln(lst,' HA SALIDO EL NUMERO ',num:1,' ',nu[num],'VECES')
                    end;
                 writeln(lst);
                 suma:=0;
                 for num:=1 to numfinal do suma:=suma+nu[num];
                 write(lst,' Sumatorio = calculo sobre ',suma:1,' numeros.');
                 writeln;
                 writeln
            end
          else
            begin
                 writeln;
                 writeln(' CALCULO DE ',numaleatorio:4,' NUMEROS ENTRE EL 1 Y EL ', numfinal);
                 writeln;
                 for num:=1 to numfinal do
                    begin
                         writeln(' HA SALIDO EL NUMERO ',num:1,' ',nu[num],' VECES');
                         if num/22 = int(num/22) then
                           begin
                                write('......mas......');
                                z := readkey;
                                clrscr;
                                writeln(' CALCULO DE ',numaleatorio:4,' NUMEROS ENTRE EL 1 Y EL ',numfinal);
                                writeln
                           end
                    end;
                 writeln;
                 suma:=0;
                 for num:=1 to numfinal do suma:=suma+nu[num];
                 write(' Sumatorio = calculo sobre ',suma:1,' numeros.');
                 writeln;
                 writeln
            end;
         write(' Quieres seguir en esta utilidad: S/N  ');
         z:=readkey
     end
end;

(****************************************************************************)
(*                    DIVISORES DE UN NUMERO                                *)
(****************************************************************************)

procedure divisores;
var division,numero,nume : real;
begin
     clrscr;
     z:='s';
     while (z = 's') or (z = 'S') do
          begin
               clrscr;
               writeln;
               writeln('                        ͻ');
               writeln('                          CALCULO DE DIVISORES DE UN NUMERO  ');
               writeln('                        ͼ');
               writeln;
               writeln;
               write(' Introduce numero para calcular sus divisores: ');
               read(numero);
               writeln;
               writeln;
               write(' Divisores = ');
               nume := 0;
               repeat
                       nume := nume + 1;
                       division:=numero/nume;
                       if int(division) = division then
                         begin
                              if wherex < 74 then write(nume:1:0,' ') else
                                begin
                                     writeln;
                                     write(nume:1:0,' ')
                                end
                         end;
               until numero = nume;
               writeln;
               writeln;
               write(' Quieres seguir en esta utilidad: S/N  ');
               z:=readkey
          end;
     writeln;
     writeln
end;

(**************************************************************************)
(*                   CALCULO DE NUMEROS PRIMOS                            *)
(**************************************************************************)

function comp(n:real) : boolean;
var d,p : real;
begin
     d := 0;
     p := 0;
     repeat
           p := p + 1;
           if n/p = int(n/p) then d := d + 1;
           if d > 1 then
             begin
                  comp := false;
                  exit
             end;
     until p = 19;
     comp := true
end;

procedure primos;
var t,num : real;
    primo : boolean;
    fichero : text;
begin
     assign(fichero,'primos.dat');
     clrscr;
     z := ' ';
     writeln;
     writeln('                     ͻ');
     writeln('                          CALCULO DE NUMEROS PRIMOS    ');
     writeln('                     ͼ');
     writeln;
     writeln;
     writeln(' Quieres el resultado en un fichero (primos.dat)  S/N ');
     write(' Si se introduce un trmino distinto a "S" la salida se har por impresora');
     z := readkey;
     if z = 's' then z := 'S';
     if z = 'S' then rewrite(fichero);
     writeln;
     writeln;
     write(' Hasta que nmero quieres la tabla? ');
     read(t);
     clrscr;
     if z = 'S' then writeln(fichero);
     writeln;
     if z <> 'S' then writeln(lst);
     if z = 'S' then writeln(fichero,'                          TABLA DE NUMEROS PRIMOS');
     writeln('                          TABLA DE NUMEROS PRIMOS');
     if z <> 'S' then writeln(lst,'                          TABLA DE NUMEROS PRIMOS');
     if z = 'S' then writeln(fichero);
     writeln;
     if z <> 'S' then writeln(lst);
     if z = 'S' then writeln(fichero);
     writeln;
     if z <> 'S' then writeln(lst);
     if z = 'S' then write(fichero,' ');
     write(' 7 11 13 17 19 ');
     if z <> 'S' then write(lst,' 7 11 13 17 19 ');
     num := 19;
     repeat
           num := num + 1;
           primo := comp(num);
           if primo = true then
             begin
                  if z = 'S' then write(fichero,num:1:0,' ');
                  write(num:1:0,' ');
                  if z <> 'S' then write(lst,num:1:0,' ')
             end;
           if wherex > 74 then
             begin
                  if z = 'S' then writeln(fichero);
                  writeln;
                  if z <> 'S' then writeln(lst)
             end;
     until num = t;
     if z = 'S' then
       begin
            writeln(fichero);
            writeln(fichero);
            writeln(fichero);
            writeln(fichero);
            writeln(fichero,'                        FIN DE TABLA DE NUMEROS PRIMOS');
            close(fichero)
       end;
     writeln;
     writeln;
     writeln;
     writeln;
     writeln('                        FIN DE TABLA DE NUMEROS PRIMOS');
     if z <> 'S' then
       begin
            writeln(lst);
            writeln(lst);
            writeln(lst);
            writeln(lst);
            writeln(lst,'                                   FIN DE TABLA DE NUMEROS PRIMOS')
       end;
     writeln;
     writeln;
     write(' Quieres seguir en esta utilidad? S/N ');
     z:=readkey;
     if z = 'S' then primos
end;

(**************************************************************************)
(*                       MENUS PRINCIPALES 1 Y 2                          *)
(**************************************************************************)

procedure presmenu;
var c : integer;
    autor : string[31];
begin
     autor:= chr(65)+chr(108)+chr(118)+chr(97)+chr(114)+chr(111)+chr(32)+chr(67)+chr(97)+chr(110)+chr(116)+
             chr(101)+chr(105)+chr(114)+chr(111)+chr(32)+chr(77)+chr(97)+chr(114)+chr(116)+chr(105)+chr(110)+
             chr(101)+chr(122)+chr(32)+chr(40)+chr(49)+chr(57)+chr(57)+chr(49)+chr(41);
     dmatriz:=7;

     (* impresion de pantalla *)

     for c:=1 to 79 do write('');
     writeln;
     for c:=1 to 18 do
        begin
             gotoxy(1,c);
             write('');
             gotoxy(79,c);
             write('')
         end;
     gotoxy(1,19);
     for c:=1 to 79 do write('');
     gotoxy(1,20);
     for c:=20 to 24 do
        begin
             gotoxy(1,c);
             write('');
             gotoxy(79,c);
             write('')
        end;
     gotoxy(30,20); write ('');
     gotoxy(30,21); write ('');
     gotoxy(30,22); write ('');
     gotoxy(30,23); write ('');
     gotoxy(30,24); write ('');
     gotoxy(1,25);
     for c:=1 to 79 do write('');
     gotoxy(35,22);
     write('AUTOR: ',autor)
end;

procedure menu_principal2;
var opc : integer;
begin
     clrscr;
     presmenu;
     gotoxy(10,2);
     write('                                                            ');
     gotoxy(10,3);
     write('                M E N U  P R I N C I P A L   2              ');
     gotoxy(2,4);
     write('');
     gotoxy(10,6);
     write('0.......................IR AL MENU PRINCIPAL 1');
     gotoxy(10,8);
     write('1.......................');
     gotoxy(10,10);
     write('2.......................');
     gotoxy(10,12);
     write('3.......................');
     gotoxy(10,14);
     write('4.......................');
     gotoxy(10,16);
     write('5.......................');
     gotoxy(10,18);
     write('6.......................');
     gotoxy(10,22);
     write('Opcion: ');
     read(opc);
     if opc = 0 then exit;
     if opc = 1 then
     if opc = 2 then
     if opc = 3 then
     if opc = 4 then
     if opc = 5 then
     if opc = 6 then
end;

procedure menu_principal1;
begin
     gotoxy(10,2);
     write('                                                            ');
     gotoxy(10,3);
     write('                M E N U  P R I N C I P A L   1              ');
     gotoxy(2,4);
     write('');
     gotoxy(10,6);
     write('0.......................SALIR');
     gotoxy(10,8);
     write('1.......................RAZONES TRIGONOMETRICAS');
     gotoxy(10,10);
     write('2.......................SISTEMAS DE ECUACIONES');
     gotoxy(10,12);
     write('3.......................CALCULO DE PROBABILIDADES');
     gotoxy(10,14);
     write('4.......................CALCULO DE DIVISORES');
     gotoxy(10,16);
     write('5.......................TABLA DE NUMEROS PRIMOS');
     gotoxy(10,18);
     write('6.......................IR MENU PRINCIPAL 2');
     gotoxy(10,22);
     write('Opcion: ');
     read(opcion);
     if opcion = 1 then razones;
     if opcion = 2 then ecuaciones;
     if opcion = 3 then calculo;
     if opcion = 4 then divisores;
     if opcion = 5 then primos;
     if opcion = 6 then menu_principal2
end;

procedure monocolor;
var c : integer;
label atras;
begin
     c := 0;
     clrscr;
     gotoxy(20,13);
     write('Monitor Monocromo o Color: ( M o C)');
     atras:
     gotoxy(57,13);
     z := readkey;
     if (z = 'M') or (z = 'm') then
       begin
            textcolor(7);
            textbackground(0);
            c := 1
       end;
     if (z = 'C') or (z = 'c') then
       begin
            textcolor(14);
            textbackground(1);
            c := 1
       end;
     if c = 0 then goto atras;
end;


(*****************************************************************************)
(*                       PROCEDIMIENTO PRINCIPAL                              )
(*****************************************************************************)

BEGIN

     initsyserror;
     monocolor;
     clrscr;
     portada;
     clrscr;
     inicio:
     clrscr;
     presmenu;
     menu_principal1;
     if opcion = 0 then goto fin;
     goto inicio;
     fin:
         textcolor(7);
         textbackground(0);
         cuadro

END.