program ordenacion_de_tablas(input,output);

uses crt,dos;

const fintbl = 32000;

type tabla = array [0..fintbl] of integer;

var hour,min,sec,sec100 : word;
    hora,minutos,segundos,s100,p,n : integer;
    opcion,opcion2 : char;
    a : tabla;
    car : char;

label inicio;

procedure inicializar;
begin
     for p := 1 to fintbl do a[p] := 0
end;

procedure insercion_directa;
var i,j,x : integer;
begin
     write('Ordenando por Insercion Directa');
     for i := 2 to n do
        begin
             x := a[i];
             a[0] := x;
             j := i - 1;
             while x < a[j] do
                  begin
                       a[j+1] := a[j];
                       j := j - 1
                  end;
             a[j+1] := x
        end
end;

procedure insercion_binaria;
var i,j,iz,de,m,x : integer;
begin
     write('Ordenando por Insercin Binaria');
     for i := 2 to n do
        begin
             x := a[i];
             iz := 1;
             de := i - 1;
             while iz <= de do
                  begin
                       m := (iz + de) div 2;
                       if x < a[m] then de := m - 1 else iz := m + 1
                  end;
             for j := i - 1 downto iz do a[j+1] := a[j];
             a[iz] := x
        end
end;

procedure seleccion_directa;
var i,j,k,x : integer;
begin
     write('Ordenando por Seleccin Directa');
     for i := 1 to n - 1 do
        begin
             k := i;
             x := a[i];
             for j := i + 1 to n do
                begin
                     if a[j] < x then
                       begin
                            k := j;
                            x := a[j]
                       end
                end;
             a[k] := a[i];
             a[i] := x
        end
end;

procedure intercambio_directo; (* burbuja *)
var i,j,x : integer;
begin
     write('Ordenando por Burbuja');
     for i := 2 to n do
        begin
             for j := n downto i do
                begin
                     if a[j - 1] > a[j] then
                       begin
                            x := a[j - 1];
                            a[j - 1] := a[j];
                            a[j] := x
                       end
                end
        end
end;

procedure burbuja_mejorada;
var i,j,x : integer;
    interc : boolean;
begin
     write('Ordenando por Burbuja Mejorada');
     interc := true;
     i := 2;
     while ((i <= n) and (interc)) do
          begin
               interc := false;
               for j := n downto i do
                  begin
                       if a[j - 1] > a[j] then
                         begin
                              x := a[j - 1];
                              a[j - 1] := a[j];
                              a[j] := x;
                              interc := true
                         end
                  end;
               i := i + 1
          end
end;

procedure sacudida;
var j,k,iz,de,x : integer;
begin
     write('Ordenando por Sacudida');
     iz := 2;
     de := n;
     k := n;
     repeat
           for j := de downto iz do
              begin
                   if a[j - 1] > a[j] then
                     begin
                          x := a[j - 1];
                          a[j - 1] := a[j];
                          a[j] := x;
                          k := j
                     end
              end;
           iz := k + 1;
           for j := iz to de do
              begin
                   if a[j - 1] > a[j] then
                     begin
                          x := a[j - 1];
                          a[j - 1] := a[j];
                          a[j] := x;
                          k := j
                     end
              end;
           de := k - 1;
     until iz > de
end;

procedure crear_tabla;
var azar : integer;
begin
     clrscr;
     writeln;
     writeln('                   C R E A C I O N  D E  T A B L A ');
     writeln('                   =============================== ');
     writeln;
     writeln('                   0 . . . . Volver al menu anterior ');
     writeln;
     writeln('                   1 . . . . Crear tabla en peor caso ');
     writeln;
     writeln('                   2 . . . . Crear tabla aleatoria ');
     writeln;
     writeln('                   3 . . . . Especificar amplitud de la tabla ');
     writeln;
     writeln;
     write('                   Opcion: ');
     opcion2 := readkey;
     if opcion2 = '0' then exit;
     if opcion2 = '1' then
       begin
            for p := 0 to n do a[n-p] := p
       end;
     if opcion2 = '2' then
       begin
            for p := 1 to n do
               begin
                    azar := random(n) + 1;
                    a[p] := azar
               end
       end;
     if opcion2 = '3' then
       begin
            clrscr;
            gotoxy(30,15);
            write('Cuantos numeros?  ');
            read(n)
       end;
     if (opcion2 = '1') or (opcion2 = '2') then
       begin
            clrscr;
            for p := 1 to n do write(a[p],' ');
       end;
     crear_tabla
end;

procedure monocolor;
label atras;
begin
     clrscr;
     n := 0;
     gotoxy(20,13);
     write('Monitor Monocromo o Color: (M o C)');
     atras:
     gotoxy(57,13);
     car := readkey;
     if (car = 'M') or (car = 'm') then
       begin
            textcolor(7);
            textbackground(0);
            n := 1
       end;
     if (car = 'C') or (car = 'c') then
       begin
            textcolor(14);
            textbackground(1);
            n := 1
       end;
     if n = 0 then goto atras
end;

BEGIN

n := 10;
monocolor;
inicializar;
inicio:
hora := 0; minutos := 0; segundos := 0; s100 := 0;
hour := 0; min := 0; sec := 0; sec100 := 0;
clrscr;
writeln;
writeln('           O R D E N A C I O N  D E  T A B L A S ');
writeln('           ===================================== ');
writeln;
writeln;
writeln('           0 . . . . Volver a Sistema Operativo ');
writeln;
writeln('           1 . . . . Crear Tabla ');
writeln;
writeln('           2 . . . . Ordenar por metodo de Insercion Directa ');
writeln;
writeln('           3 . . . . Ordenar por metodo de Insercion Binaria ');
writeln;
writeln('           4 . . . . Ordenar por metodo de Seleccion Directa ');
writeln;
writeln('           5 . . . . Ordenar por metodo de Intercambio Directo (Burbuja)');
writeln;
writeln('           6 . . . . Ordenar por metodo de Burbuja Mejorada ');
writeln;
writeln('           7 . . . . Ordenar por metodo de Sacudida ');
writeln;
writeln;
write('           Opcion:  ');
opcion := readkey;
clrscr;
writeln; writeln; writeln;
if opcion = '0' then
  begin
       textcolor(7);
       textbackground(0);
       clrscr;
       halt
  end;
if (opcion >= '2') and (opcion <= '7') then
  begin
       clrscr;
       gotoxy(25,15);
       gettime(hour,min,sec,sec100);
       hora := hour; minutos := min; segundos := sec; s100 := sec100
  end;
case opcion of
    '1' : crear_tabla;
    '2' : insercion_directa;
    '3' : insercion_binaria;
    '4' : seleccion_directa;
    '5' : intercambio_directo;
    '6' : burbuja_mejorada;
    '7' : sacudida
end;
if (opcion >= '2') and (opcion <= '7') then
  begin
       gettime(hour,min,sec,sec100);
       if hour > hora then hora := hour - hora else hora := hora - hour;
       if minutos > min then minutos := minutos - min else minutos := min - minutos;
       if segundos > sec then segundos := segundos - sec else segundos := sec - segundos;
       if s100 > sec100 then s100 := s100 - sec100 else s100 := sec100 - s100;
       clrscr;
       writeln;
       writeln(' Tiempo aproximado de ordenacion: ',hora,'h ',minutos,'m ',segundos,'s ',s100,'c')
  end;
if opcion = '1' then goto inicio;
writeln;
writeln;
write(' Quieres ver la tabla ordenada? S/N ');
car := readkey;
writeln;
writeln;
if (car = 'S') or (car = 's') then
  begin
       clrscr;
       for p := 1 to n do
          begin
               write(a[p],' ');
               if wherex >= 77 then writeln
          end;
       writeln; writeln;
       car := readkey
  end;
goto inicio

END.
