program telefonica(input,output);

(* Trifas en llamadas metropolitanas de Telefnica S.A. *)

uses crt,drivers;

type registro = record
             minutos : integer;
             dinero : real;
          end;
     tipotarifa = (dia,noche);

var tarifa : array [1..12] of registro;
    tiempo,tiemaux : integer;
    dinero,ptsmin : real;
    car : char;


procedure crear_tarifas(tipo : tipotarifa);
begin
     tarifa[1].minutos  := 1;
     tarifa[2].minutos  := 2;
     tarifa[3].minutos  := 3;
     tarifa[4].minutos  := 4;
     tarifa[5].minutos  := 5;
     tarifa[6].minutos  := 6;
     tarifa[7].minutos  := 9;
     tarifa[8].minutos  := 12;
     tarifa[9].minutos  := 15;
     tarifa[10].minutos := 30;
     tarifa[11].minutos := 45;
     tarifa[12].minutos := 60;
     if tipo = dia then
       begin
            tarifa[1].dinero  := 13.11;
            tarifa[2].dinero  := 13.11;
            tarifa[3].dinero  := 13.11;
            tarifa[4].dinero  := 19.67;
            tarifa[5].dinero  := 19.67;
            tarifa[6].dinero  := 19.67;
            tarifa[7].dinero  := 26.22;
            tarifa[8].dinero  := 32.78;
            tarifa[9].dinero  := 39.33;
            tarifa[10].dinero := 72.10;
            tarifa[11].dinero := 104.88;
            tarifa[12].dinero := 137.66;
            ptsmin := (tarifa[12].dinero - tarifa[11].dinero) / 15;
       end
     else
       begin
            tarifa[1].dinero  := 13.11;
            tarifa[2].dinero  := 13.11;
            tarifa[3].dinero  := 13.11;
            tarifa[4].dinero  := 13.11;
            tarifa[5].dinero  := 19.67;
            tarifa[6].dinero  := 19.67;
            tarifa[7].dinero  := 26.22;
            tarifa[8].dinero  := 26.22;
            tarifa[9].dinero  := 32.78;
            tarifa[10].dinero := 59.00;
            tarifa[11].dinero := 85.21;
            tarifa[12].dinero := 104.88;
            ptsmin := (tarifa[12].dinero - tarifa[11].dinero) / 15;
       end;
end;


procedure leer_datos;
var seguir : boolean;
  procedure tipo_tarifa;
  begin
       writeln(' Diurna   -> Lunes a viernes de 8 a 22h, sbados de 8 a 14h.');
       writeln(' Nocturna -> Lunes a viernes de 22 a 8h del da siguiente,');
       writeln('             sbados a partir de las 14h,');
       writeln('             domingos y festivos de mbito nacional todo el da.');
       writeln;
  end;
begin
     car := ' ';
     seguir := false;
     tipo_tarifa;
     write(' Introduzca tipo de tarifa (D)iurna o (N)octurna: (Retorno=Nocturna)  ');
     repeat
           car := readkey;
           if (car='D') or (car='d') then writeln('Diurna')
             else if (car='N') or (car='n') or (car=chr(13)) then
                 writeln('Nocturna');
           if (car='D') or (car='d') or (car='N') or
              (car='n') or (car=chr(13)) then seguir := true
             else
                 begin
                      writeln;
                      writeln(' Error en introduccin de tipo, pulse "D" o "N".');
                      write(' Introduzca tipo de tarifa (D)iurna o (N)octurna: (Retorno=Nocturna)  ');
                 end;
     until seguir;
     if (car='D') or (car='d') then crear_tarifas(dia)
       else crear_tarifas(noche);
     seguir := false;
     write(' Introduzca tiempo en minutos: ');
     repeat
           readln(tiempo);
           if tiempo > 0 then seguir := true
             else
                 begin
                      writeln(' Error en introduccin de tiempo, el tiempo tiene que ser mayor que cero.');
                      write(' Introduzca tiempo en minutos: ');
                 end;
     until seguir;
     tiemaux := tiempo;
end;


procedure entrada;
begin
     writeln;
     writeln(' Trifas de Telefnica en Llamadas Metropolitanas.');
     writeln(' Versin 1.00');
     writeln(' Copyright (c) 1994-95 Alvaro Canteiro. 21 Enero 1995.');
     writeln;
     writeln(' *** Actualizado con las tarifas segn B.O.E de 30-07-94.');
     writeln;
end;


procedure procesar;
var mayor : boolean;

  function exacto : real;
  var n : integer;
      encontrado : boolean;
      aux : real;
  begin
       encontrado := false;
       n := 0;
       repeat
             n := n + 1;
             if tarifa[n].minutos = tiempo then encontrado := true;
       until (encontrado) or (n = 12);
       if encontrado then aux := tarifa[n].dinero else aux := 0;
       exacto := aux;
  end;

  function calcular : real;
  var n : integer;
      encontrado : boolean;
      aux : real;
      aux1,aux2 : integer;
  begin
       encontrado := false;
       n := 0;
       repeat
             n := n + 1;
             if tarifa[n].minutos > tiempo then encontrado := true;
       until (encontrado) or (n = 12);
       aux1 := trunc( tarifa[n].dinero - tarifa[n-1].dinero );
       aux2 := tarifa[n].minutos - tarifa[n-1].minutos;
       aux := aux1 / aux2;
       aux := aux * ( tiempo - tarifa[n-1].minutos );
       aux := aux + tarifa[n-1].dinero;
       calcular := aux;
  end;

begin
     mayor := false;
     if tiempo > 60 then
       begin
            tiempo := tiempo - 60;
            dinero := tarifa[12].dinero + (tiempo*ptsmin);
       end
     else
       begin
            dinero := exacto;
            if dinero = 0 then dinero := calcular;
       end;
end;

procedure devolver_resultados;
  function iva(din : real) : real;
  begin
       iva := din*16/100;
  end;
begin
     writeln;
     write(' Tipo de tarifa   : ');
     if (car = 'D') or (car = 'd') then writeln('Diurna.')
       else writeln('Nocturna.');
     writeln(' Tiempo de llamada: ',tiemaux,' minutos.');
     writeln;
     writeln(' Coste aproximado           = ',dinero:1:0,' pesetas.');
     dinero := dinero + iva(dinero);
     writeln(' Coste aproximado + 16% IVA = ',dinero:1:0,' pesetas.');
     writeln;
end;



BEGIN

      initsyserror;
      entrada;
      leer_datos;
      procesar;
      devolver_resultados;

END.