program WinTrojanScan(input,output);
uses crt,dos;

const version = '0.01';
      dia = 13;
      mes = 'Marzo';
      ano = '1999';

var windir : string;
    noset : boolean;
    n : integer;

procedure entrada;
begin
     writeln;
     writeln(' WinTrojan Scan & Clean. Version ',version);
     writeln(' Autor: Alvaro Canteiro. ',dia,' de ',mes,' de ',ano,'.');
     writeln;
end;

function existe_fichero(fichero : string) : boolean;
var dirinfo : Searchrec;
    aux : boolean;
begin
     findfirst(fichero,archive,dirinfo);
     if doserror = 0 then aux := true else aux := false;
     existe_fichero := aux;
end;

function comprueba(fich : string) : boolean;
var fichero : string;
begin
     if noset then
       fichero := fich
       else
           fichero := windir + '\' + fich;
     writeln(fichero);
     if existe_fichero(fichero) then comprueba := true else comprueba := false;
end;

procedure detectar;

   function rastrear : boolean;
   var aux : boolean;

       procedure encontrado(descripcion : string; var enc : boolean);
       begin
            writeln(' Encontrado ',descripcion,'.');
            if enc = false then enc := true;
       end;

   begin

        aux := false;

        if comprueba('system\exe1') then encontrado('BackOrifice 1',aux);
        if comprueba('system\e.exe') then encontrado('BackOrifice 2',aux);
        if comprueba('system\ .exe') then encontrado('BackOrifice 3',aux);
        if comprueba('system\windll.dll') then encontrado('BackOrifice 4',aux);
        if comprueba('patch.exe') then encontrado('Netbus',aux);
        if comprueba('system\mschv32.exe') then encontrado('Masters Paradise, blaze and control trojan',aux);
        if comprueba('system\mschv.exe') then encontrado('Masters Paradise',aux);
        if comprueba('system\bubbel.exe') then encontrado('Bubbel Trojan',aux);
        if comprueba('system\system.exe') then encontrado('NetSpy Trojan',aux);
        if comprueba('ppmod1.sys') then encontrado('Phineas Trojan',aux);
        if comprueba('ppmod2.sys') then encontrado('Phineas',aux);
        if comprueba('windll.exe') then encontrado('Girlfriend Trojan',aux);
        if comprueba('system\odbc.exe') then encontrado('Telecommando Trojan',aux);
        if comprueba('*.tmp') then encontrado('Acid Silver Trojan',aux);
        if comprueba('system\ska.*') then encontrado('Email Worm',aux);
        if comprueba('system\server.exe') then encontrado('New Trojan',aux);

        if aux then rastrear := true else rastrear := false;

   end;

begin
     if not rastrear then writeln(' BackOrifice no detectado. ')
end;

procedure borrar;
var windir : string;
    fichero : string;

   procedure borra(fichero,descripcion : string);
   var f : file of byte;
   begin
        assign(f,fichero);
        erase(f);
        writeln(' Eliminado ',descripcion,'.');
   end;

begin

     if comprueba('system\exe1') then borra(fichero,'BackOrifice 1');
     if comprueba('system\ .exe') then borra(fichero,'BackOrifice 2');
     if comprueba('system\e.exe') then borra(fichero,'BackOrifice 3');
     if comprueba('system\windll.dll') then borra(fichero,'BackOrifice 4');
     if comprueba('patch.exe') then borra(fichero,'Netbus');
     if comprueba('system\mschv32.exe') then borra(fichero,'Masters Paradise, blaze and control trojan');
     if comprueba('system\mschv.exe') then borra(fichero,'Masters Paradise');
     if comprueba('system\bubbel.exe') then borra(fichero,'Bubbel Trojan');
     if comprueba('system\system.exe') then borra(fichero,'NetSpy Trojan');
     if comprueba('ppmod1.sys') then borra(fichero,'Phineas Trojan');
     if comprueba('ppmod2.sys') then borra(fichero,'Phineas');
     if comprueba('windll.exe') then borra(fichero,'Girlfriend Trojan');
     if comprueba('system\odbc.exe') then borra(fichero,'Telecommando Trojan');
     if comprueba('*.tmp') then borra(fichero,'Acid Silver Trojan');
     if comprueba('system\ska.*') then borra(fichero,'Email Worm');
     if comprueba('system\server.exe') then borra(fichero,'New Trojan');

     writeln;
     writeln(' Se recomienda reiniciar el ordenador. ');
     writeln;

end;

procedure ayuda;
begin
     writeln(' Modo de uso: "acmscan [parmetros] [noset]" ');
     writeln;
     writeln(' detectar -> Rastrea la presencia de wintrojanos. ');
     writeln(' borrar   -> Borra los wintrojanos que puedan ser detectados. ');
     writeln(' lista    -> Lista de trojanos actualmente detectados y borrados. ');
     writeln(' listaf   -> Crea un fichero con los trojanos detectados y borrados. ');
     writeln(' acerca   -> Informacin acerca del programa y de su autor. ');
     writeln;
     writeln(' noset    -> Busca en el directorio actual en vez de en el directorio. ');
     writeln('             al que apunta la variable de entorno de windows. ');
     writeln;
     writeln(' Si se usa el parmetro noset se deber esta situado en el subdirectorio');
     writeln(' unidad:\windows\. ');
     writeln;
end;

procedure lista_trojan(pantalla : boolean);
var f1 : text;
   procedure escribe(cadena : string);
   begin
        if pantalla then writeln(cadena)
          else writeln(f1,cadena);
   end;
begin
     clrscr;

     if not pantalla then
       begin
            assign(f1,'acmscan.tro');
            rewrite(f1);
            writeln(f1);
       end;

     escribe(' Lista de trojanos detectados y borrados por WinTrojanScan - Total = 16');
     escribe(' ----------------------------------------------------------------------');
     escribe('');
     escribe(' Nombre                                         Detectado   Borrado ');
     escribe('');
     escribe(' Acid Silver Trojan                           -     X          X    ');
     escribe(' BackOrifice 1                                -     X          X    ');
     escribe(' BackOrifice 2                                -     X          X    ');
     escribe(' BackOrifice 3                                -     X          X    ');
     escribe(' BackOrifice 4                                -     X          X    ');
     escribe(' Bubbel Trojan                                -     X          X    ');
     escribe(' Email Worm                                   -     X          X    ');
     escribe(' Girlfriend Trojan                            -     X          X    ');
     escribe(' Netbus                                       -     X          X    ');
     escribe(' New Trojan                                   -     X          X    ');
     escribe(' Masters Paradise, blaze and control trojan   -     X          X    ');
     escribe(' Masters Paradise                             -     X          X    ');
     escribe(' NetSpy Trojan                                -     X          X    ');
     escribe(' Phineas                                      -     X          X    ');
     escribe(' Phineas Trojan                               -     X          X    ');
     escribe(' Telecommando Trojan                          -     X          X    ');

     if not pantalla then close(f1);

end;

procedure acerca;
begin
     clrscr;
     writeln;
     writeln(' WinTrojanScan version ',version);
     writeln(' --------------------------');
     writeln;
     writeln(' WinTrojan es un minidetector de trojanos de Windows 9x y Windows NT. Como');
     writeln(' bien podeis comprobar no me  he  comido demasiado la cabeza en hacer esta');
     writeln(' utilidad, simplemente he tratado de hacer un producto que funcione.');
     writeln;
     writeln(' Puede ser ejecutado tanto desde ms-dos como desde  windows,  el motivo es');
     writeln(' que de esa forma puede ser ejecutado sin tener que iniciar Windows.');
     writeln;
     writeln(' Si quereis colaborar con  mas  trojanos  podeis enviarme sus nombres y su');
     writeln(' descripcin a cualquiera de mis direcciones de red. ');
     writeln;
     writeln(' Autor: Alvaro Canteiro. ',ano);
     writeln;
     writeln('        Fidonet: 2:344/14.50 - Subnet: 93:344/101.2 ');
     writeln('        email: acm@cryogen.com - http:\\www.cryogen.com/acm ');
     writeln;
end;

procedure procesar;
begin
     if paramcount = 2 then
       if paramstr(2) = 'noset' then noset := true else noset := false;
     if paramcount = 1 then
       begin
            if paramstr(1) = 'detectar' then detectar
              else if paramstr(1) = 'borrar' then borrar
                  else if paramstr(1) = 'lista' then lista_trojan(true)
                      else if paramstr(1) = 'listaf' then lista_trojan(false)
                          else if paramstr(1) = 'acerca' then acerca
                              else ayuda;
       end
     else ayuda;
end;

procedure extrae_windir;
begin
     windir := getenv('windir');
end;

BEGIN

     entrada;
     extrae_windir;
     procesar;


END.

