program denormts;

{$N+$E+}

var e : extended;
    d : double;
    s : single;

BEGIN

     writeln;
     writeln(' Testing support and printing od denormals');
     writeln(' =========================================');
     writeln;
     write(' Coprocessor is: ');
     case test8087 of
        0: writeln('Emulator');
        1: writeln('Intel 8087 or compatible');
        2: writeln('Intel 80287 or compatible');
        3: writeln('Intel 80387 or compatible');
     end;
     writeln;
     s := 1.18e-38;
     s := s * 3.90625e-3;
     if s = 0 then
        writeln(' SINGLE denormals not supported')
        else
            begin
                 writeln(' SINGLE denormals supported');
                 writeln(' SINGLE denormal print as    ',s);
                 writeln(' Denormal should be printed as 4.60943...E-0041');
            end;
     writeln;
     d := 2.24e-308;
     d := d * 3.90625e-3;
     if d = 0 then
        writeln(' DOUBLE denormals not supported')
        else
            begin
                 writeln(' DOUBLE denormals supported');
                 writeln(' DOUBLE denormal prints as    ',d);
                 writeln(' Denormal should be printed as 8,75...e-0311');
            end;
     writeln;
     e := 3.37e-4932;
     e := e * 3.90625e-3;
     if e = 0 then
        writeln(' EXTENDED denormals not supported')
        else
            begin
                 writeln(' EXTENDED denormals supported');
                 writeln(' EXTENDED denormal print as     ',e);
                 writeln(' EXTENDED denormal should be printed as 1.3164...e-4934');
            end;
     readln;
end.