program enlazar_lista(input,output);

type linea = packed array [1..40] of char;
     enlace = ^personal;
     personal = record
                 nombre : linea;
                 siguiente : enlace
                end;

var item,puntero,ultimo : enlace;
    opcion : 1..4;
    cuenta : 0..40;
    nombreitem : linea;

procedure leernombre(var nombre : linea);
begin
     for cuenta := 1 to 40 do nombre[cuenta] := ' ';
     cuenta := 0;
     while not eoln do
          begin
               cuenta := cuenta + 1;
               read(nombre[cuenta])
          end;
     readln
end;

procedure visualizar;
begin
     writeln;
     puntero := ultimo;
     while puntero <> nil do
          begin
               item := puntero;
               writeln(item^.nombre);
               puntero := item^.siguiente
          end
end;

procedure crear;
begin
     new(item);
     write('Nuevo nombre: ');
     leernombre(item^.nombre);
     item^.siguiente := nil;
     puntero := item;
     while not ((item^.nombre[1] in ['F','f'])
            and (item^.nombre[2] in ['I','i'])
            and (item^.nombre[3] in ['N','n'])) do
          begin
               new(item);
               write('Nuevo nombre: ');
               leernombre(item^.nombre);
               item^.siguiente := puntero;
               puntero := item
          end;
     ultimo := item^.siguiente;
     visualizar
end;

procedure anadir;
begin
     new(item);
     writeln;
     write('Nuevo nombre: ');
     leernombre(item^.nombre);
     write('Colocar delante de: (presionar RETORNO si es el ultimo elemento): ');
     leernombre(nombreitem);
     if nombreitem[1] = ' ' then
       begin
            item^.siguiente := ultimo;
            ultimo := item
       end
     else
       begin
            puntero := ultimo;
            while (puntero^.nombre <> nombreitem) and
                  (puntero^.siguiente <> nil) do puntero := puntero^.siguiente;
            item^.siguiente := puntero^.siguiente;
            puntero^.siguiente := item
       end;
     visualizar
end;

procedure suprimir;
begin
     writeln;
     write('Nombre que va a ser suprimido: ');
     leernombre(nombreitem);
     if ultimo^.nombre = nombreitem then
       begin
            item := ultimo;
            ultimo := item^.siguiente;
            dispose(item)
       end
     else
       begin
            puntero := ultimo;
            item := ultimo^.siguiente;
            while (item^.nombre <> nombreitem) and (item^.siguiente <> nil) do
                 begin
                      puntero := item;
                      item := item^.siguiente
                 end;
            if item^.nombre = nombreitem then
              begin
                   puntero^.siguiente := item^.siguiente;
                   dispose(item)
              end
       end;
     visualizar
end;

procedure menu;
begin
     writeln('Menu principal: ');
     writeln;
     writeln('  1 - Crear la lista enlazada ');
     writeln;
     writeln('  2 - Aadir un componente ');
     writeln;
     writeln('  3 - Suprimir un componente ');
     writeln;
     writeln('  4 - Fin ');
     writeln;
     write('Introduzca su eleccin (1, 2, 3 o 4) -> ');
     readln(opcion);
     writeln
end;

BEGIN

repeat
      writeln;
      menu;
      case opcion of
          1 : crear;
          2 : anadir;
          3 : suprimir;
          4 :
      end;
until opcion = 4
end.



