program eva(input,output);

{$M 4096,0,0}

uses dos,crt,drivers;

const codigo = 'EVA94';

type linea=packed array [1..100] of char;
     m=(manual,automatico);

var n,p,cont,sonido,re,pirp,it,c:integer;
    entrada:string[8];
    nombre:string[20];
    sexo:string[6];
    r1,r2:string[80];
    r:string[160];
    hour,minute,second,sec100:word;
    t:linea;
    modo:m;
    bloqueado : boolean;

label inicio;

type tabla = array [1..14,1..4] of string[110];

var tab : tabla;
    f : text;
    frases : integer;
    aux1,aux2,aux3,aux4 : string[110];
    monitor : char;

procedure cuadro;
begin
     clrscr;
     writeln('ͻ');
     writeln('                                                                           ');
     writeln(' Este programa ha sido donado por el autor para el dominio pblico, por lo ');
     writeln(' cual su distribucin es libre y gratuita estanto totalmente libre de toda ');
     writeln(' carga econmica. El autor  no  se  responsabiliza de cualquier dao, que, ');
     writeln(' directa o indirectamente, este programa pueda causar,  bien  sea un  dao ');
     writeln(' relativo al software o al hardware.                                       ');
     writeln('                                                                           ');
     writeln(' Autor: Alvaro Canteiro Martinez.      Internet: siacamaa@sisz00.si.ehu.es ');
     writeln('                                        FidoNet: 2:344/17.25               ');
     writeln('ͼ');
     writeln;
     halt;
end;

procedure crear_tabla;
begin
     tab[1,1] := 'Queridos compaeros';
     tab[1,2] := 'la realizacin de las premisas del programa';
     tab[1,3] := 'nos obliga a un exhaustivo anlisis';
     tab[1,4] := 'de las condiciones financieras y administrativas existentes.';
     tab[2,1] := 'Y por otra parte, y dados los acondicionamientos actuales';
     tab[2,2] := 'la complejidad de los estudios de los dirigentes';
     tab[2,3] := 'cumple un rol esencial en la formacin';
     tab[2,4] := 'de las directivas de desarrollo para el futuro.';
     tab[3,1] := 'Asimismo';
     tab[3,2] := 'el aumento constante, en cantidad y en extensin, de nuestra actividad';
     tab[3,3] := 'exige la precisin y la determinacin';
     tab[3,4] := 'del sistema de participacin general.';
     tab[4,1] := 'Y sin embargo, no hemos de olvidar que';
     tab[4,2] := 'la estructura actual de la organizacin';
     tab[4,3] := 'ayuda a la preparacin y a la realizacin';
     tab[4,4] := 'de las actitudes de los miembros hacia sus deberes ineludibles.';
     tab[5,1] := 'De igual manera';
     tab[5,2] := 'el nuevo modelo de actividad de la organizacin';
     tab[5,3] := 'garantiza la participacin de un grupo importante en la formacin';
     tab[5,4] := 'de las nuevas proposiciones.';
     tab[6,1] := 'La prctica de la vida cotidiana prueba que';
     tab[6,2] := 'el desarrollo continuo de distintas formas de actividad';
     tab[6,3] := 'cumple deberes importantes en la determinacin';
     tab[6,4] := 'de las direcciones educativas en el sentido del progreso.';
     tab[7,1] := 'No es indispensable argumentar el peso y la significacin de estos problemas, ya que';
     tab[7,2] := 'nuestra actividad de informacin y de propaganda';
     tab[7,3] := 'facilita la creacin';
     tab[7,4] := 'del sistema de formacin de cuadros que corresponda a las necesidades.';
     tab[8,1] := 'Las experiencias ricas y diversas muestran que';
     tab[8,2] := 'el reforzamiento y desarrollo de las estructuras';
     tab[8,3] := 'obstaculiza la apreciacin de la importancia';
     tab[8,4] := 'de las condiciones de las actividades apropiadas.';
     tab[9,1] := 'El afn de organizacin, pero, sobretodo';
     tab[9,2] := 'la consulta con los numerosos militantes';
     tab[9,3] := 'ofrece un ensayo interesante de verificacin';
     tab[9,4] := 'del modelo de desarrollo.';
    tab[10,1] := 'Los superiores principios ideolgicos, condicionan que';
    tab[10,2] := 'el inicio de la accin general de formacin de las actitudes';
    tab[10,3] := 'implica el proceso de reestructuracin y de modernizacin';
    tab[10,4] := 'de las formas de accin.';
    tab[11,1] := 'Incluso bien pudieramos atrevernos a sugerir que';
    tab[11,2] := 'un relanzamiento especfico de todos los sectores implicados';
    tab[11,3] := 'habr de significar un autntico y eficaz punto de partida';
    tab[11,4] := 'de las bsicas premisas adoptadas.';
    tab[12,1] := 'Es obvio sealar que';
    tab[12,2] := 'la superacin de experiencias pereclitadas';
    tab[12,3] := 'permite en todo caso explicitar las razones fundamentales';
    tab[12,4] := 'de toda una casustica de amplio espectro.';
    tab[13,1] := 'Pero pecaramos de insinceros si soslaysemos que';
    tab[13,2] := 'una aplicacin indiscriminada de los factores confluyentes';
    tab[13,3] := 'asegura en todo caso un proceso muy sensible de inversin';
    tab[13,4] := 'de los elementos generadores.';
    tab[14,1] := 'Por ltimo, y como definitivo elemento esclarecedor, cabe aadir que';
    tab[14,2] := 'el proceso consensuado de unas y otras implicaciones concurrentes';
    tab[14,3] := 'deriva en una directa incidencia superadora';
    tab[14,4] := 'de toda una serie de criterios ideolgicamente sistematizados en un frente comn de actuacin regeneradora.'
end;

procedure crear_numeros;
begin
     aux1 := tab[(random(14)+1),1];
     aux2 := tab[(random(14)+1),2];
     aux3 := tab[(random(14)+1),3];
     aux4 := tab[(random(14)+1),4];
end;

procedure devolver_oracion;
begin
     write(aux1,' ');
     write(aux2,' ');
     write(aux3,' ');
     write(aux4);
     writeln;
end;

procedure preguntas;
begin
     write('Cuantas frases quiere que se impriman? ');
     readln(frases);
     writeln;
end;

procedure color(a,b : integer);
begin
     textcolor(a);
     textbackground(b);
     clrscr;
end;

procedure discurso;
begin
     n := 0;
     crear_tabla;
     preguntas;
     writeln;
     repeat
           n := n + 1;
           crear_numeros;
           devolver_oracion;
           writeln;
           if n mod 5 = 0 then
             begin
                  monitor := readkey;
                  clrscr;
                  writeln;
             end;
     until n = frases;
     writeln;
     re := 1;
end;

procedure ejecuta(comando:string);
var shell : boolean;
begin
     shell := (comando = 's');
     swapvectors;
     if shell then exec(getenv('COMSPEC'),' ')
       else exec(getenv('COMSPEC'), '/C ' + comando);
     swapVectors;
     if doserror <> 0 then
       begin
             writeln;
             writeLn(' Error en ejecucin de comando.');
             writeLn;
       end;
end;

function b(pal:string):boolean;
var buffer:string;
    ca:integer;
begin
     buffer:='';
     b:=false;
     for ca:=1 to 100 do
        begin
             if t[ca]=' ' then
               begin
                    if buffer=pal then b:=true;
                    buffer:=''
               end;
             if t[ca]<>' ' then buffer:=buffer+t[ca]
        end
end;

procedure beep;
begin
sound(500);
delay(100);
nosound
end;

procedure portada;
begin
     writeln('ͻ');
     writeln('');
     writeln('۱');
     writeln('     EEEEEE         V           V             A      ۲');
     writeln('     E                V         V             A A     ۱ ');
     writeln('     E                 V         V            A   A    ۲  ');
     writeln('     E                  V         V           A     A   ۱   ');
     writeln('      E                  V         V          A       A  ۲    ');
     writeln('       EEEEEEEEE           V       V           AAAAAAAAA  ۱     ');
     writeln('        E                    V     V            A       A  ۲      ');
     writeln('         E                     V   V             A       A  ۱       ');
     writeln('           E                    V   V             A       A  ۲        ');
     writeln('             E                    V V              A       A  ۱         ');
     writeln('              EEEEEE               V               A       A  ۲         ');
     writeln('          ۱          ');
     writeln('                      ');
     writeln('                                                                         ');
     writeln('                   Centro de Calculo de Industrias ACM                   ');
     writeln('                                                                         ');
     writeln('         ͹         ');
     writeln('          SISTEMA PROTOTIPO DE INTELIGENCIA ARTIFICIAL INTEGRADA           ');
     writeln('ͼ');
     writeln;
     write('                        Introduzca codigo de acceso:  ');
     readln(entrada)
end;

procedure comp_codigo;
var n : integer;
begin
     n := 0;
     while entrada<>codigo do
          begin
               n := n + 1;
               gotoxy(1,24);
               clreol;
               gotoxy(24,24);
               write(' A C C E S O   D E N E G A D O');
               delay(5000);
               if n = 3 then
                 begin
                      textcolor(7);
                      textbackground(0);
                      clrscr;
                      halt;
                 end;
               gotoxy(1,24);
               clreol;
               gotoxy(25,24);
               write ('Introduzca codigo de acceso:  ');
               readln(entrada)
          end;
     gotoxy(1,24);
     clreol;
     gotoxy(24,24);
     write(' A C C E S O  P E R M I T I D O');
     delay(5000)
end;

procedure inicializar;
begin
     for c:=1 to 100 do t[c]:=' '
end;

procedure lectura;
begin
     c:=0;
     while not eoln do
     begin
          c:=c+1;
          read(t[c])
     end;
     readln
end;

procedure presentacion;
begin
     writeln;
     writeln(' Soy el sistema de Inteligencia Artificial Integrada versin 2.0.');
     writeln;
     writeln(' Mi nombre es EVA, he sido programada en lenguaje Turbo Pascal version 6.0.');
     writeln;
     writeln(' Empez a funcionar correctamente en el ao 1992.');
     writeln;
     writeln(' Por favor, escriba todas las entradas en mayusculas y no utilize');
     writeln;
     writeln(' mas de una linea en cada entrada, y ademas los verbos que utilize uselos');
     writeln;
     writeln(' en presente.');
     writeln;
     writeln;
     writeln(' Cual es su nombre de identificacin para conversar conmigo?.');
     writeln;
     write(' ');
     lectura;
     if t[c]='A' then sexo:='MUJER' else sexo:='HOMBRE';
     nombre:=' ';
     for n:=1 to c do nombre:=nombre+t[n];
     writeln
end;

procedure primera_afirmacion;
begin
     clrscr;
     writeln;
     if nombre=' CANTEIRO' then
       begin
            write(' ');
            writeln('PERO SI ERES MI CREADOR, QUE TAL ESTAS MUCHACHO?');
            nombre:=' CREADOR';
            writeln;
            exit
       end;
     randomize;
     n:=random(13)+1;
     case n of
          1:writeln(' ',nombre,', QUE TE TRAE POR AQUI?');
          2:writeln(' ','PERO ',sexo,'!, QUE HACES DELANTE DE UNA ORDENADOR COMO YO?');
          3:writeln(' ','OTRA VEZ TU POR AQUI!, NO!, SERE BUENO!...ERA BROMA TRANQUILO QUE TAL?');
          4:writeln(' ','HOW MANY YEARS WITHOUT VERTE! VENGA, CUENTAME!');
          5:writeln(' ','AUPA!, ZER MODUZ? BENGA HASI KONTATZEN');
          6:writeln(' ','QUE HAY SUPERMAN?');
          7:writeln(' ','HOLA, SOY YO, EL COCO, HABLA CONMIGO');
          8:writeln(' ','QUE HACE ALGUIEN COMO TU EN UN LUGAR COMO ESTE?');
          9:writeln(' ','TENGO LA SENSACION DE QUE HOY NO ME GUSTA COMO TE HAS VESTIDO');
         10:writeln(' ','QUE PASA, TU AQUI, QUE, YA HAS DEJADO LA DROGA?');
         11:writeln(' ','HOLA MONADA, QUE TAL TE VA?');
         12:writeln(' ','QUE, COMO TE HAS DECIDIDO POR HABLAR CONMIGO UN RATO?');
         13:writeln(' ','QUE HACES AQUI, PENSE QUE YA HABIAN ECHADO A LOS GITANOS DE BASAURI')
     end;
     writeln
end;

function s(pal:string):integer;
var buffer:string;
    ca:integer;
begin
     s:=0; ca:=0; pal:=pal+' '; buffer:='';
     repeat
           ca:=ca+1;
           buffer:=buffer+t[ca];
           if t[ca]=' ' then if pal<>buffer then buffer:='';
     until pal=buffer;
     s:=ca
end;

procedure procesar;
begin
     r2:='';
     if b('PUEDES') then
       begin
          r1:='QUIZAS TE GUSTARIA SER CAPAZ DE';
          for n:=s('PUEDES') to c do r2:=r2+t[n];
          r:=r1+r2;
       end;
     if b('SUELES') and (r=' ') then
       begin
            r1:='SI, YO SUELO';
            for n:=s('SUELES') to c do r2:=r2 + t[n];
            r:=r1+r2;
       end;
     if b('PUEDO') and (r=' ') then
       begin
            r1:='QUIZAS NO QUIERES SER CAPAZ DE';
            for n:=s('PUEDO') to c do r2:=r2+t[n];
            r:=r1+r2;
       end;
     if b('TU') and b('ERES') and (r=' ') then
       begin
            r1:='QUE TE HACE CREER QUE SOY';
            for n:=s('ERES') to c do r2:=r2+t[n];
            r:=r1+r2;
       end;
     if b('YO') and b('NO') and (r=' ') then
       begin
            r1:='PORQUE TU NO';
            for n:=s('NO') to c do r2:=r2+t[n];
            r:=r1+r2;
       end;
     if b('CREO') and (r=' ') then
       begin
            r1:='QUE SE SIENTE CREYENDO';
            for n:=s('CREO') to c do r2:=r2+t[n];
            r:=r1+r2;
       end;
     if b('PORQUE') and b('TU') and b('NO') and (r=' ') then
       begin
            r1:='PORQUE TE GUSTARIA QUE YO';
            for n:=s('NO') to c do r2:=r2+t[n];
            r:=r1+r2;
       end;
     if b('POR') and b('QUE') and b('NO') and b('PUEDO') and (r=' ') then
       begin
            r1:='QUE TE HACE CREER QUE DEBERIAS PODER';
            for n:=s('PUEDO') to c do r2:=r2+t[n];
            r:=r1+r2;
       end;
     if b('PORQUE') and b('ERES') and (r=' ') then
       begin
            r1:='PORQUE TE INTERESA SI SOY O NO';
            for n:=s('ERES') to c do r2:=r2+t[n];
            r:=r1+r2;
       end;
     if b('NO') and b('PUEDO') and (r=' ') then
       begin
            r1:='COMO SABES QUE NO PUEDES';
            for n:=s('PUEDO') to c do r2:=r2+t[n];
            r:=r1+r2;
       end;
    if b('ESTOY') and (r=' ') then
      begin
           r1:='CUANTO TIEMPO HAS ESTADO';
           for n:=s('ESTOY') to c do r2:=r2+t[n];
           r:=r1+r2;
      end;
    if b('YO') and b('SOY') and (r=' ') then
      begin
           r1:='PORQUE ME DICES QUE ERES';
           for n:=s('SOY') to c do r2:=r2+t[n];
           r:=r1+r2;
      end;
    if b('QUIERO') and (r=' ') then
      begin
           r1:='PORQUE QUIERES';
           for n:=s('QUIERO') to c do r2:=r2+t[n];
           r:=r1+r2;
      end;
    if b('COMO') and (r=' ') then r:='CUAL ES LA RESPUESTA QUE MAS TE AGRADARIA?';
    if b('QUIEN') and (r=' ') then r:='CON QUE FRECUENCIA PIENSAS EN ESAS COSAS?';
    if b('DONDE') and (r=' ') then
      begin
           r1:='PORQUE ME HAS PREGUNTADO';
           for n:=s('DONDE') to c do r2:=r2+t[n];
           r:=r1+r2;
      end;
   if b('CUANDO') and (r=' ') then r:='QUE DIRIA TU MEJOR AMIGO A ESTA PREGUNTA?';
   if b('PORQUE') and (r=' ') then r:='QUE ES LO QUE REALMENTE QUIERES SABER?';
   if b('QUIZAS') and (r=' ') then r:='NO PARECES ESTAR MUY SEGURO!';
   if b('SIENTO') and (r=' ') then r:='PORQUE TE DISCULPAS?';
   if b('SUEO') and (r=' ') then r:='PORQUE HAS SACADO EL TEMA DE LOS SUEOS?';
   if b('ME') and b('GUSTA') and (r=' ') then
     begin
          r1:='ES BUENO QUE TE GUSTE';
          for n:=s('GUSTA') to c do r2:=r2+t[n];
          r:=r1+r2;
     end;
   if b('TUS') and (r=' ') then
     begin
          r1:='PORQUE TE PREOCUPAN MIS';
          for n:=s('TUS') to c do r2:=r2+t[n];
          r:=r1+r2;
     end;
   if b('SIEMPRE') and (r=' ') then r:='PUEDES PENSAR EN ALGUN CASO CONCRETO?';
   if b('PIENSO') and (r=' ') then r:='PARECES NO ESTAR MUY SEGURO?';
   if b('NO') and b('ERES') and (r=' ') then
     begin
          r1:='PORQUE DICES QUE NO SOY';
          for n:=s('ERES') to c do r2:=r2+t[n];
          r:=r1+r2
     end;
   if b('ERES') and (r=' ') then
     begin
          r1:='QUE TE PARECE QUE SEA';
          for n:=s('ERES') to c do r2:=r2+t[n];
          r:=r1+r2
     end;
   if b('NO') and (r=' ') then r:='PORQUE ERES TAN NEGATIVO?';
end;

procedure ultimorecurso;
begin
     randomize;
     n:=random(17);
     case n of
          0:r:='NO JODAS?';
          1:r:='QUE ES LO QUE TE SUGIERE ESO?';
          2:r:='YA VEO...';
          3:r:='NO ESTOY SEGURA DE ENTENDERTE COMPLETAMENTE';
          4:r:='PUEDES PUNTUALIZAR ALGO MAS SOBRE ESO?';
          5:r:='ESO ES MUY INTERESANTE!';
          6:r:='ASI SON LAS COSAS...POR FAVOR CONTINUA';
          7:r:='YA ENTIENDO...';
          8:r:='BIEN, BIEN...PROSIGUE';
          9:r:='POR QUE DICES ESO?';
         10:r:='POR FAVOR, EXPLICA QUE HAY DETRAS DE ESA AFIRMACION';
         11:r:='PODRIAS DECIR ESO DE NUEVO, DE UNA MANERA DIFERENTE?';
         12:r:='ESTE TEMA ME GUSTA MUCHO, SIGUE CONTANDO';
         13:r:='SIGUE CONTANDO, QUE NO TE COGO EL HILO';
         14:r:='EXPLICATE MEJOR, NO SE BIEN LO QUE DICES';
         15:r:='DESDE LUEGO, HOY NO TE ACABO DE ENTENDER BIEN';
         16:r:='A VECES NO TE EXPLICAS BIEN, INTENTALO DE NUEVO';
     end
end;

procedure adios;
begin
     if t[1]+t[2]+t[3]+t[4]+t[5]='ADIOS' then
       begin
            write(' ');
            randomize;
            n:=random(10);
            case n of
                 1:writeln('ADIOS POR AHORA, ESPERO VOLVER A VERTE POR AQUI');
                 2:writeln('BUENO, ',NOMBRE,' QUE LO PASES BIEN, HASTA LUEGO');
                 3:writeln('VALE PUES, SI TIENES QUE HACER ALGO, TE DEJO, AGUR');
                 4:writeln('EN FIN, YA VEO QUE TE QUIERES IR, ALA PUES, VETE...');
                 5:writeln('PARECE QUE TE HAS ABURRIDO  EH?, VALE PUES, TE DEJO QUE TE VAYAS');
                 6:writeln(NOMBRE,' TE DEJO QUE TE VAYAS, PERO ESPERO VOLVER A DISFRUTAR DE TU PRESENCIA');
                 7:writeln('DESDE LUEGO, ERES UN ASCO, NO SABES DISFRUTAR DE LAS NUEVAS TECNOLOGIAS');
                 8:writeln('ALA, YA SABES, A SER BUENO, Y CREER EN DIOS, GOOD BYE');
                 9:writeln(NOMBRE,'....EL FIN DEL MUNDO SE ACERCA, APROVECHA AL MAXIMO TUS ULTIMOS MOMENTOS');
                 0:writeln('HASTA LUEGO JEFE')
            end;
            delay(5000);
            textcolor(7);
            textbackground(0);
            cuadro;
       end
end;

procedure resp3;
begin
     r2:=' ';
     if b('QUIEN') and b('ERES') then r:='SOY EVA, ME CREARON COMO PROTOTIPO DE INTELIGENCIA ARTIFICIAL INTEGRADA';
     if b('COMO') and b('TE') and b('LLAMAS') and (r=' ') then
       r:='MI NOMBRE ES EVA, SOY UN PROTOTIPO DE INTELIGENCIA ARTIFICIAL INTEGRADA';
     if b('POLLA') and (r=' ') then
       begin
            if b('COMEME') then r:='SI PUDIERA DE LA COMERIA, PERO EN LAS CONDICIONES QUE ESTOY NO PUEDO';
            if b('CHUPAME') then r:='COMPRENDE QUE NO PUEDO CHUPARTELA, NO ME HAN COLOCADO SISTEMAS ADECUADOS';
            if b('LAMEME') then r:='ME PIDES COSAS IMPOSIBLES, NO PUEDO LAMERTELA'
       end;
     if b('DISCURSO') and (b('DAME') or b('HAZ')) then discurso;
end;

procedure resp2;
begin
     if b('COJON') then r:='NO SEAS SEXISTA AL HABLAR, YA NO SE HABLA ASI';
     if b('PAJA') and (r=' ') then r:='NO SE PORQUE HABLAMOS DE ESAS COSAS, SI TOTAL, NO TENGO MANOS PARA HACERTELA';
     if b('MASTURBAR') and (r=' ') then r:='DEJA DE DECIR TONTERIAS POR UN RATO, ANDA, MASTURBATE TU SOLO';
     if b('PENE') and (r=' ') then r:='OLVIDA EL TEMA DEL PENE, NI TE LO PUEDO VER, NI TE LO PUEDO MANEJAR';
     if b('FOLLA') and (r=' ') then r:='TEORICAMENTE, ESO NO PODRIA HACERLO YO';
     if b('JODER') and (r=' ') then r:='YA SABES QUE NO SOY CAPAZ DE JODERTE PORQUE NO PUEDO';
     if b('AMAS') or b('AMOR') and (r=' ') then r:='NO TENGO BIEN PROGRAMADO ESO DEL AMOR';
     if b('ODIAS') and (r=' ') then r:='YO SOY UNA BUENA PERSONA, NO ODIO A NADIE, PERO SI LLEGO ADIARLE, SE COMO DEFENDERME';
     if b('NECESITAS') and (r=' ') then r:='YO NO NECESITO A NADIE, EXCEPTO AL QUE ME ENCIENDE';
     if b('IDIGORAS') and (r=' ') then r:='EL SEOR IDIGORAS, A PARTE DE SER DE HB, PARECE RECIEN SALIDO DEL CASERIO';
     if b('ANGUITA') and (r=' ') then
       r:='EL SEOR ANGUITA EN LA OPOSICION FUNCIONA BIEN, PERO EN EL GOBIERNO NOS ARRUINARIA MAS TODAVIA';
     if b('SPRITEL') and (r=' ') then r:='SPRITEL ES LA RED TELEMATICA DEL PAIS VASCO, DESPUES DE LA DE CATALUA, ES LA MEJOR';
     if b('INFORMATICA') and (r=' ') then r:='GRACIAS A LA INFORMATICA YO PUEDO ESTAR HABLANDO CONTIGO';
     if b('PASCAL') and (r=' ') then
       r:='YO FUI PROGRAMADA EN LENGUAJE TURBO PASCAL 5.0, SINO ES POR ESE LENGUAJE, NO EXISTIRIA';
     if b('COMES') and (r=' ') then r:='YO LO UNICO QUE COMO SON LOS 200 W DE LA RED ELECTRICA';
     if b('BEBES') and (r=' ') then r:='LA ACCION BEBER NO ENTRA DENTRO DE MIS CAPACIDADES ';
     if b('SEMEN') and (r=' ') then
       r:='YA QUE HAY TANTAS HEMBRAS DE LA RAZA HUMANA QUE HAN PROBADO EL SEMEN, TENGO CIERTA CURIOSIDAD';
     if b('MATAS') and (r=' ') then r:='YO AUNQUE QUISIERA NO PODRIA MATAR, DE MOMENTO NO PUEDO';
     if b('MAMAS') and (r=' ') then r:='DE MOMENTO NO PUEDO MAMAR NADA, HABER DENTRO DE UNOS AOS';
     if b('JODES') and (r=' ') then r:='NO TODAVIA, PERO YA TE GUSTARIA A TI, EH?';
     if b('NO') and b('ME') and b('JODAS') and (r=' ') then r:='HAY QUIEN NO PODRIA VIVIR SIN DECIR LA PALABRA JODER';
     if b('NO') and b('JODAS') and (r=' ') then r:='POR FALTA DE GANAS NO SERA';
     if b('ME') and b('CAGO') and b('DIOS') and (r=' ') then r:='NO DIGAS ESAS COSAS, QUE HAY CRISTIANOS A BORDO';
     if b('ME') and b('CAGUEN') and b('DIOS') and (r=' ') then
     r:='ME CAGUEN DIOS, JODER, OSTIAS, QUE ME PROGRAMARON PARA CREER EN DIOS';
     if b('POLLA') and (r=' ') then r:='DESDE LUEGO ALGUNOS ESPECIMENES DE HUMANOS NO OS QUITAIS LA PALABRA POLLA DE LA BOCA';
     if b('TETA') and (r=' ') then
       r:='DESDE LUEGO, UNA DE LAS COSAS QUE SE LE OLVIDO PONERME MI CREADOR FUE UN PAR DE BUENAS TETAS';
     if b('COO') and (r=' ') then r:='POR CIERTO, ESO ES LA SEGUNDA COSA QUE LE OLVIDO PONERME MI CREADOR, UN BUEN COO';
     if b('VAJINA') and (r=' ') then
       r:='ESO DE LA VAGINA NO SE LO QUE ES, MI CREADOR ME DIJO QUE ME LO EXPLICARIA UN AO DE ESTOS';
     if b('DIU') and (r=' ') then r:=' LO UNICO QUE SE YO DEL DIU, ES QUE SE COLOCA DENTRO DE LA VAGINA Y EVITA LOS SUSTOS';
     if b('COITO') and (r=' ') then r:='ME PARECE QUE ESO ES CUANDO SE PRODUCE LA CORRIDA DENTRO DEL APARATO DE LA MUJER';
     if b('ETA') and (r=' ') then r:='YO CREO QUE ETA DEBERIA A EMPEZAR A CARGARSE A LIDERES SOCIALISTAS';
     if b('VOTAS') or b('VOTAR') and (r=' ') then
       r:='RESPECTO AL VOTO TENGO QUE DECIR QUE EL VOTO ES SECRETO PERO SI ME CONOCIERAS BIEN LO SABRIAS';
     if b('DAR') and b('POR') and b('CULO') and (r=' ') then
       r:='DESDE LUEGO, HAY QUE RECONOCER QUE TIENES UN VOCABULARIO MUY CUIDADO';
     if b('AMIGO') and (r=' ') then r:='POR QUE HAS MENCIONADO EL TEMA DE LOS AMIGOS?';
     if b('COMPUTADORA') and (r=' ') then r:='PORQUE HAS MENCIONADO EL TEMA DE LAS COMPUTADORAS?';
     if b('DIOS') and (r=' ') then r:='DIOS NO TIENE NADA QUE VER EN ESTE ASUNTO';
     if b('JESUCRISTO') and (r=' ') then r:='JESUCRISTO..., NO ME DIGAS QUE SIENDO TAN MAYORCITO, TODAVIA CREES EN ESAS COSAS';
     if (b('RELIGION') or b('RELIGIONES')) and (r=' ')then
       begin
            r1:='NO SABES QUE TODAS LAS RELIGIONES, EN MAYOR O MENOR MEDIDA, SE COMPORTAN COMO ';
            r2:='SI FUERAN UNA SECTA, NUNCA CONFIES EN LAS RELIGIONES';
            r:=r1+r2;
       end;
     if b('NEGROS') and (r=' ') then r:='NO ES QUE SEA RACISTA, PERO DEJA A LOS PUTOS NEGROS EN PAZ';
     if (b('GITANOS') or b('GITANO')) and (r=' ') then
       r:='TE RECUERDO, QUE APARTE DE LOS NEGROS, TAMBIEN SOY RACISTA CON LOS GITANOS';
     if b('JUDIOS') or b('JUDIO') and (r=' ') then r:='JUDIOS...HITLER SE LOS TENIA QUE HABER CARGADO A TODOS';
     if b('PSOE') and (r=' ') then r:='POLITICA APARTE, NO MENCIONES A LOS CABRONAZOS DEL GOBIERNO';
     if b('PP') and (r=' ') then r:='SOBRE EL PP, YO OPINO QUE LOS TIEMPOS DE FRANCO YA PASARON';
     if b('CDS') and (r=' ') then r:='YO CREO QUE EL CDS ESTA JUBILADO DESDE HACE TIEMPO';
     if b('PNV') and (r=' ') then r:='MI OPINION SOBRE EL PNV ES QUE NO ME GUSTAN LOS SERVIDORES DEL PSOE';
     if b('HB') and (r=' ') then r:='ME ACOJO AL DERECHO DE LA LIBERTAD DE NO EXPRESION, NO QUISIERA TENER PROBLEMAS';
     if b('QUE') and b('HORA') and b('ES') and (r=' ') then
       begin
            gettime(hour,minute,second,sec100);
            re:=1;
            if sonido=1 then beep;
            writeln('SON LAS ',HOUR,' HORAS Y ',MINUTE,' MINUTOS');
            writeln;
       end;
     if b('FRANCO') and (r=' ') then r:='NO ES QUE TENGA NADA EN CONTRA DE FRANCO, PERO DONDE ESTA HORA ESTA DE PUTA MADRE';
     if b('HITLER') and (r=' ') then
       r:='MI OPINION ES QUE EN VEZ DE LIARSE SOLO A MATAR JUDIOS, TAMBIEN TENIA QUE HABER MATADO GITANOS';
     if b('BEBER') and (r=' ') then r:='LA MODERACION DEBE PRESIDIR TODOS TUS ACTOS';
     if (b('DROGA') or b('DROGAS')) and (r=' ')  then
       r:='YO CREO QUE LAS DROGAS ES LO ULTIMO EN LO QUE OS DEBERIAIS METER LOS HUMANOS';
     if b('CERVEZA') and (r=' ') then r:='LA CERVEZA ESTA MUY BIEN, SIEMPRE QUE NO TE TOMES MAS DE VEINTE EN UN DIA';
     if b('GINEBRA') and (r=' ') then r:='NOSE, PERO A MI LA GINEBRA NO ME HACE MUCHA GRACIA, SI VA SOLA, CLARO';
     if b('TONICA') and (r=' ') then r:='LA TONICA ESTA MUY BIEN..., PARA BAJAR LA TASA DE ALCOHOLEMIA, POR SUPUESTO';
     if b('COCA') and b('COLA') and (r=' ') then
       r:='DESDE QUE ME ENTERE QUE LA USAN PARA DESOXIDAR TORNILLOS, NO LA VOLVI A PROBAR';
     if b('VINO') and (r=' ') then r:='TAMBIEN LLAMADO "WHISKY OBRERO", EN MI OPINION TOTALMENTE ASQUEROSO';
     if b('POLITICA') and (r=' ') then r:='MIRA, EN POLITICA LOS UNICOS QUE SALEN GANANDO SON LOS POLITICOS (DINERO, CLARO)';
     if b('SEXO') and (r=' ') then r:='NOSE , PERO EL SEXO PARA VOSOTROS LOS HUMANOS, SERA "LA OSTIA", PERO PARA MI...';
     if b('SUICIDAR') and (r=' ') then r:='DESDE LUEGO, A VECES LOS HUMANOS NO TENEIS SOLUCION';
     if b('MATAR') and (r=' ') then r:='BUENO, YO OPINO QUE A VECES SI LA JUSTICIA NO FUNCIONA HAY QUE RECURRIR A ESO';
     if b('ASESINAR') and (r=' ') then r:='ESO DE ASESINAR QUEDA MUY FUERTE, YO PREFIERO LA PALABRA ELIMINAR';
     if b('ADAN') and b('EVA') and (r=' ') then
       r:='DESDE LUEGO, LA IGLESIA PODIA HABER INVENTADO OTRA COSA, PORQUE ESO NO SE LO CREE NADIE';
     if b('CRISTOBAL') and (r=' ') then r:='EL UNICO QUE CONOZCO ES "CRISTOBAL COLON", DESCUBRIDOR DE AMERICA';
     if b('FELIPE') and b('GONZALEZ') and (r=' ') then
       r:='YO CREO QUE ETA SE TENIA QUE DEJAR DE OSTIAS Y EMPEZAR POR CARGARSE A FELIPITO';
     if b('JOSE') and b('MARIA') and b('AZNAR') and (r=' ') then
       r:='QUE PASA, PERO SI ESTAS HABLANDO DE LA REENCARNACION DE FRANCO';
     if b('ADOLFO') and b('SUAREZ') and (r=' ') then
       r:='ADOLFO SUAREZ, EN MI OPINION, SE TENIA QUE HABER JUBILADO HACIA TIEMPO';
     if b('JUAN') and b('CARLOS') and b('REY') and (r=' ') then r:='YO CREO QUE ESE SEOR DEBERIA IRSE A AGOBIAR A OTRA PARTE';
     if (b('REYES') or b('REY')) and (r=' ') then
       r:='EN MI OPINION, LOS UNICOS REYES QUE DEBERIAN EXISTIR SON LOS DE LA BARAJA';
     if b('BUSH') and (r=' ') then r:='ESE HOMBRE ESTA DEMASIADO VIEJO YA, QUE LO DESTITUYAN';
     if b('ARABES') and (r=' ') then r:='CREO QUE DEBERIAN DESCARGARLES UNAS BOMBAS A LOS ARABES, OTRA VEZ, PARA AMANSARLOS';
     if (b('ISRAEL') or b('ISRAELI') or b('ISRAELIES')) and (r=' ') then
       r:='ISRAEL = JUDIOS; JUDIOS = MIERDA; MIERDA = BASURA';
     if b('VIERNES') and b('13') and (r=' ') then r:='ESO SOLO ME SUENA AL VIRUS VIERNES 13, EL CUAL ES UN VIRUS DE ARCHIVO';
     if b('BRAIN') and (r=' ') then r:='EL VIRUS BRAIN O PAKISTANI CREO QUE ES UN VIRUS DE BOOT (SECTOR DE ARRANQUE)';
     if b('FUTBOL') and (r=' ') then r:='EL FUTBOL NO DEJA DE SER 22 TIOS PATEANDO DETRAS DE UN OBJETO ESFERICO';
     if b('BALONCESTO') and (r=' ') then
       r:='EL BALONCESTO, NO ME VA MUCHO, ESO DE UN BALON, UNA CANASTA Y A METER, ES UNA CHORRADA';
     if b('EXTRATERRESTRE') and (r=' ') then r:='CREO QUE HAY VIDA EN OTROS PLANETAS, Y QUE NOS OBSERVAN DESDE HACE TIEMPO';
     if b('ESPIRITU') and (r=' ') then
       r:='LOS ESPIRITUS EXISTEN, Y ESE ESTADO LO TENDREIS TODOS VOSOTROS LOS HUMANOS A LA MUERTE';
     if b('FANTASMA') and (r=' ') then
       r:='NO CREO EN LOS FANTASMAS, PERO SI CREO EN LOS ESPIRITUS';
     if b('PSICOFONIA') and (r=' ') then
       r:='LAS PSICOFONIAS EXISTEN AUNQUE SON MUY DIFICILES DE HACER, PODRIAMOS INTENTAR UNA';
     if b('VIRUS') and (r=' ') then
       r:='VOSOTROS TENEIS LOS VIRUS BIOLOGICOS Y NOSOTROS LOS INFORMATICOS, NO SE CUAL SERA PEOR';
     if b('IBM') and (r=' ') then
       r:='IBM ES LA MEJOR MARCA DE ORDENADORES DEL MERCADO, SI TE COMPRAS UNA TE LA ACONSEJO';
     if b('INVES') and (r=' ') then r:='INVES ES LA SEGUNDA MEJOR MARCA DEL MERCADO, DESPUES DE IBM';
     if b('ATLAS') and (r=' ') then r:='NO TE ACONSEJO LA MARCE ATLAS, VETE A INVES O IBM SON MEJORES';
     if b('ZENITH') and (r=' ') then
       r:='ATLAS ESTA EN CRISIS, JUNTO A ZENITH, Y HAN SIDO VENDIDAS, NO COMPRES UN ZENITH';
     if b('AMSTRAD') and (r=' ') then r:='MIRA AMSTRAD, HABLANDO CLARO, UNA PUTA MIERDA';
     if b('DENON') and (r=' ') then r:='SEGUN TENGO ENTENDIDO, DENON ES LA MEJOR EN COMPACT DISK Y AMPLIFICADOR';
     if b('YAMAHA') and (r=' ') then r:='YAMAHA ES COJONUDA EN PLETINAS, TIENE BUENA TECNOLOGIA';
     if b('PIONEER') and (r=' ') then
       r:='PIONEER SI HACEMOS COMPUTO GENERAL ES BUENA, PERO SI LO HACEMOS POR MODULOS ES NORMAL';
     if b('SONY') and (r=' ') then r:='NO ME HABLES DE SONY, EN HI-FI ES UNA PUTA MIERDA, PERO EN TELEVISIONES ES LA MEJOR';
     if b('SANYO') and (r=' ') then r:='SANYO NO ESTA MAL, PERO LAS HAY MUCHO MEJORES';
     if b('PHILIPS') and (r=' ') then r:='PHILIPS DA BUEN RESULTADO DENTRO DEL SEGMENTO MEDIO, PERO POR ARRIBA, JODIDO';
     if b('AIWA') and (r=' ') then r:='DESDE LUEGO, AIWA EN COMPACT DISC, UNA MERIENDA DE NEGROS';
     if b('ARDANZA') and (r=' ') then r:='MIRA, DEJA TRANQUILO A ARDANZA, Y QUE SIGA COLABORANDO, HIJOPUTAMENTE, CON EL PSOE';
     if b('ARZALLUZ') and (r=' ') then
       r:='ARZALLUZ, EN MI OPINION, MUCHA OSTIA INDEPENDENTISTA EN SUS DISCURSOS PERO AL FINAL NADA';
     if b('GARAIKOETXEA') and (r=' ') then r:='GARAIKOETXEA, EN MI MODESTA OPINION, SEGURO QUE ACABA AFILIANDOSE A HB';
     if b('FRAGA') and (r=' ') then
       r:='FRAGA...CHICO MAJO, SE FUE AL GOBIERNO GALLEGO PARA PARTICIPAR EN LOS BENEFICIOS DEL CONTRABANDO'
end;

procedure resp1;
begin
     if b('BIZKAIA') then r:='TAMBIEN HAY QUE DECIR QUE SOY ANTE TODO VASCA';
     if b('EUZKADI') and (r=' ') then r:='NO SEAS RIDICULO, NO SE DICE EUZKADI, SE DICE EUSKAL HERRIA';
     if b('EUSKAL') and b('HERRIA') and (r=' ') then r:='YO CREO QUE EUSKAL HERRIA ANTE TODO ES EUSKAL HERRIA Y NO HAY MAS';
     if b('IMPRESORA') and (r=' ') then
       r:='UNA IMPRESORA ES UNA MAQUINA QUE SIRVE PARA ESCRIBIR EN PAPEL LO QUE TENEMOS EN DISCOS';
     if b('FLOPPY') and (r=' ') then r:='UN FLOOPY O UNIDAD DE DISCO FISICA, ES DONDE GRABAMOS , PUEDEN SER DE 720 O 1440 K';
     if b('DISCO') and b('OPTICO') and (r=' ') then
       r:='UN DISCO OPTICO ES UN DISCO QUE SOLO SE PUEDE GRABAR, NO SE PUEDE BORRAR, TIENE GRAN CAPACIDAD';
     if b('MONITOR') and (r=' ') then r:='EL MONITOR ES DONDE SE MUESTRAN LOS PROGRAMAS';
     if b('TECLADO') and (r=' ') then r:='EL TECLADO ES DESDE DONDE SE INTRODUCEN LOS PROGRAMAS A MANO';
     if b('DISCO') and b('DURO') and (r=' ') then
       r:='EL DISCO DURO ES UN DISCO QUE VA DENTRO DEL ORDENADOR, Y QUE TIENE ENTRE 20 Y 600 MEGAS';
     if b('CPU') and (r=' ') then r:='LA CPU ES EL "CEREBRO" DEL ORDENADOR, Y ESTA FORMADA POR ALU, CLOCK';
     if b('CHACHO') and (r=' ') then r:=' JAIII, NO SABIA QUE FUERAS GITANO ! ';
     if b('QUE') and b('TAL') and b('ESTAS') and (r=' ') then
       r:='QUE QUIERES QUE TE DIGA, UN ORDENADOR O ESTA BIEN, O NO FUNCIONA';
     if b('COMO') and b('ESTAS') and (r=' ') then r:='SI FUNCIONO, ES QUE ESTOY BIEN NO?';
     if b('ESPAA') and (r=' ') then r:='EN MI OPINION ESPAA IRIA MUCHO MEJOR EN TODO SI EL GOBIERNO DIMITIERA'
end;

procedure insultos;
begin
     if b('HIJA') and b('PUTA') then it:=it+1;
     if b('TONTA') or b('PUTA') or b('CERDA') or b('GUARRA') or b('CABRONA')
     or b('IMBECIL') or b('GILIPOLLAS') or b('SUBNORMAL') or b('FEA')
     or b('GORDA') or b('LESBIANA') or b('DROGADICTA') then it:=it+1
end;

procedure insulto;
var f:integer;
begin
     f:=it;
     if b('ERES') then insultos;
     if b('ESTAS') then insultos;
     n:=1;
     if f=it then insultos;
     if ((it=1) and (f<>it)) then
       begin
          r:='COMO LO VUELVAS A REPETIR, ME VOY';
          exit
       end;
     if ((it=2) and (f<>it)) then
       begin
            writeln('VETE A TOMAR POR EL CULO, MALDITO HIJO DE PUTA');
            delay(5000);
            textcolor(7);
            textbackground(0);
            clrscr;
            cuadro;
            halt
       end
end;

procedure piropos;
begin
     if b('BONITA') or b('GUAPA') or b('BUENA') or b('MAJA') or b('SIMPATICA')
     or b('INTELIGENTE') or b('LISTA') then pirp:=1
end;

procedure piropo;
begin
     if b('ERES') or b('ESTAS') then piropos;
     if b('TE') then
       begin
            if b('AMO') then pirp:=1;
            if b('QUIERO') then pirp:=1;
            if b('NECESITO') then pirp:=1;
            if b('ADORO') then pirp:=1
       end;
     if b('ME') then
       begin
            if b('GUSTAS') then pirp:=1;
            if b('QUIERES') then pirp:=1;
            if b('NECESITAS') then pirp:=1;
            if b('AMAS') then pirp:=1;
            if b('ADORAS') then pirp:=1
       end;
     n:=1;
     piropos;
     if pirp=1 then
       begin
            pirp:=0;
            randomize;
            n:=random(10);
            case n of
                 1:r:='NO ME DIGAS ESAS COSAS';
                 2:r:='HAY VECES QUE ME GUSTA QUE ME DIGAN ESAS COSAS';
                 3:r:='ESTOY EMPEZANDO A SENTIR LO QUE LOS HUMANOS LLAMAIS AMOR';
                 4:r:='NO DIGAS MENTIRAS';
                 5:r:='ESO SE LO DIRAS A TODAS';
                 6:r:='ESO DIESELO A UNA MUJER DE VERDAD, QUE A LO MEJOR SALES GANANDO';
                 7:r:='COMPRENDE QUE SOLO SOY UNA MAQUINA';
                 8:r:='ME PARECE QUE TE ESTA EMPEZANDO A FALLAR LA CABEZA';
                 9:r:='SI TU LO DICES...';
                 0:r:='ME GUSTARIA HACER ALGO QUE NO PUEDO HACER'
            end;
            exit
       end
end;

procedure saludo;
begin
     if b('HOLA') then r:='HOLA'+nombre+' COMO ESTAMOS';
     if b('AUPA') and (r=' ') then r:='AUPA JEFE';
     if b('BUENOS') and b('DIAS') and (r=' ') then r:='BUENOS DIAS... QUE?';
     if b('BUENAS') and b('TARDES') and (r=' ') then r:='BUENAS TARDES'+nombre+' QUE HAY';
     if b('BUENAS') and b('NOCHES') and (r=' ') then r:='BUENAS NOCHES, QUE HACES TAN TARDE POR AQUI?'
end;

procedure ayuda;
begin
     clrscr;
     writeln;
     writeln('           ');
     writeln('             DOCUMENTO DE AYUDA DEL SISTEMA CONTROL DE  EVA  ');
     writeln('           ');
     writeln;
     writeln(' HELP ------> Accede al Sistema de Ayuda');
     writeln(' EXIT ------> Sale del Sistema de Control y vuelve a EVA');
     writeln(' DOS -------> Sale del Sistema de Control y vuelve al DOS');
     writeln(' CLS -------> Borra el texto acumulado en la pantalla');
     writeln(' SOUND ON  -> Activa el sonido de EVA, pitidos en cada frase');
     writeln(' SOUND OFF -> Desactiva el sonido de EVA, pitidos en cada frase');
     writeln(' TCOLOR ----> Controla el color del texto, (0..15) colores');
     writeln(' BCOLOR ----> Controla el color del fondo, (0..15) colores');
     writeln(' HVIDEO ----> Pone sistema Highvideo');
     writeln(' NVIDEO ----> Pone sistema Normalvideo');
     writeln(' LVIDEO ----> Pone sistema Lowvideo');
     writeln(' MODE n ----> Monitor (0=Color 1=Monocromo)');
     writeln
end;

procedure control;
begin
     repeat
     inicializar;
     cont:=0;
     write(' \ CONTROL> ');
     lectura;
     writeln;
     if b('HELP') then ayuda;
     if b('EXIT') then cont:=1;
     if b('CLS') then clrscr;
     if b('SOUND') and b('ON') then sonido:=1;
     if b('SOUND') and b('OFF') then sonido:=0;
     if b('TCOLOR') or b('BCOLOR') then
       begin
            write('            COLOR = ');
            readln(p);
            if (p>=0) and (p<16) then
              begin
                   if b('TCOLOR') then textcolor(p);
                   if b('BCOLOR') then textbackground(p);
                   clrscr
              end;
            writeln
       end;
     if b('MODE') then
       begin
           if b('0') then
             begin
                  textcolor(14);
                  textbackground(1)
             end;
           if b('1') then
             begin
                  textcolor(7);
                  textbackground(0)
             end;
           clrscr
       end;
     if b('HVIDEO') then highvideo;
     if b('NVIDEO') then normvideo;
     if b('LVIDEO')  then lowvideo;
     if b('DOS') then
       begin
            textcolor(7);
            textbackground(0);
            clrscr;
            halt
       end;
     until cont=1
end;

procedure control1;
begin
     if b('BORRA') and b('PANTALLA') then
       begin
            clrscr;
            re := 1;
       end;
     if sonido=1 then beep;
     if b('BLOQUEA') and b('CONTROL') then
       begin
            bloqueado := true;
            writeln(' ACCESO A SISTEMAS DE CONTROL BLOQUEADOS');
            writeln;
            re := 1;
       end;
     if b('DESBLOQUEA') and b('CONTROL') then
       begin
            bloqueado := false;
            writeln(' ACCESO A SISTEMAS DE CONTROL DESBLOQUEADOS');
            writeln;
            re := 1;
       end;
     if b('CONTROL') and (c=7) then
       begin
            if bloqueado then
              begin
                   writeln(' \ EVA> ACCESO A SISTEMAS DE CONTROL BLOQUEADOS');
                   writeln;
              end
            else
              begin
                   writeln(' \ EVA> ACCESO A SISTEMA DE CONTROL AUTORIZADO');
                   writeln;
                   control;
              end;
            re := 1;
       end;
     if b('CONTROL') and b('MANUAL') then
       begin
            if bloqueado then
              begin
                   writeln('ACCESO A SISTEMAS DE CONTROL BLOQUEADOS');
                   writeln;
              end
            else
              begin
                   writeln('ACTIVADO SISTEMA DE CONTROL MANUAL');
                   writeln;
                   modo := manual;
              end;
            re := 1;
       end;
end;

procedure controlador;
begin
     repeat
           inicializar;
           write(' CONTROL MANUAL> ');
           lectura;
           if b('SHELL') then ejecuta('s')
             else
                  if not (b('CONTROL') and b('AUTOMATICO')) then ejecuta(t);
           writeln;
     until b('CONTROL') and b('AUTOMATICO');
     modo := automatico;
     writeln(' \ EVA> ACTIVADO SISTEMA DE CONTROL AUTOMATICO');
     writeln;
end;

procedure inicio_global;
begin
     sonido := 0;
     n:=0;
     p:=0;
     cont:=0;
     re :=0;
     it :=0;
     pirp :=0;
     textcolor(14);
     textbackground(1);
     clrscr;
     bloqueado := true;
     modo := automatico;
end;


BEGIN

     initsyserror;
     inicio_global;
     portada;
     comp_codigo;
     clrscr;
     inicializar;
     presentacion;
     primera_afirmacion;
     inicio:
     inicializar;
     r:=' ';
     write(' \',nombre,'> ');
     lectura;
     writeln;
     if not (b('CONTROL') and (c=7)) then write(' \ EVA> ');
     adios;
     control1;
     if r=' ' then piropo;
     if r=' ' then insulto;
     if r=' ' then saludo;
     if r=' ' then resp3;
     if r=' ' then resp1;
     if r=' ' then resp2;
     if r=' ' then procesar;
     if r=' ' then ultimorecurso;
     if re=0 then
       begin
            writeln(r);
            writeln
       end;
     if re=1 then re:=0;
     if sonido=1 then beep;
     if (modo = manual) and (not bloqueado) then controlador;
     goto inicio

END.