program local(input,output,f);

uses crt;

var f : text;
    x : char;
    cad : string[80];

procedure inicio;
begin
     clrscr;
     writeln;
     writeln(' Centro de Calculo de ACM Software - Control de Acceso versin 1.0. ');
     writeln;
end;

function buscar(pal : string) : boolean;
var buffer : string;
    n : integer;
begin
     buffer := '';
     buscar := false;
     for n := 1 to 80 do
        begin
             if cad[n] = ' ' then
               begin
                    if buffer = pal then
                      begin
                           buscar := true;
                           exit;
                      end;
                    buffer := '';
               end;
             if cad[n] <> ' ' then buffer := buffer + cad[n];
        end;
end;

procedure abrir;
  procedure ibmps2;
  begin
       assign(f,'c:\seguir.bat');
       rewrite(f);
       writeln(f,'@echo off');
       writeln(f,'swapping off');
       writeln(f,'c:\4dos\4dos24h2');
       writeln(f,'cd c:\work');
       writeln(f,'c:\work\dosenh\numoff');
       writeln(f,'type \portada.txt');
       writeln(f,'delay 3');
       writeln(f,'cls');
       writeln(f,'alias /r c:\4dos\4dos.ali');
       writeln(f,'set /r c:\4dos\4dos.set');
       writeln(f,'subst e: c:\work\copia');
       writeln(f,'subst f: c:\');
       writeln(f,'subst g: c:\work\games');
       writeln(f,'subst h: c:\work\spectrum');
       writeln(f,'subst i: c:\work\dosenh');
       writeln(f,'subst j: c:\work\varios');
       writeln(f,'c:\work\varios\dispos');
       writeln(f,'swapping on');
       close(f);
       halt;
  end;

  procedure spectrum;
  begin
       assign(f,'c:\seguir.bat');
       rewrite(f);
       writeln(f,'@echo off');
       writeln(f,'swapping off');
       writeln(f,'c:\work\dosenh\numoff');
       writeln(f,'cd c:\work\spectrum');
       writeln(f,'type \portada.txt');
       writeln(f,'delay 3');
       writeln(f,'cls');
       writeln(f,'set /r c:\4dos\4dos.set');
       writeln(f,'c:\work\varios\dispos');
       writeln(f,'swapping on');
       writeln(f,'z80');
       writeln(f,'call autoexec.bat');
       close(f);
       halt;
  end;

  procedure kermit;
  begin
       assign(f,'c:\seguir.bat');
       rewrite(f);
       writeln(f,'@echo off');
       writeln(f,'swapping off');
       writeln(f,'c:\work\dosenh\numoff');
       writeln(f,'cd c:\modem\kermit');
       writeln(f,'type \portada.txt');
       writeln(f,'delay 3');
       writeln(f,'cls');
       writeln(f,'set c:\4dos\4dos.set');
       writeln(f,'c:\work\varios\dispos');
       writeln(f,'swapping on');
       writeln(f,'kermit');
       writeln(f,'call autoexec.bat');
       close(f);
       halt;
  end;

  procedure bbstel;
  begin
       assign(f,'c:\seguir.bat');
       rewrite(f);
       writeln(f,'@echo off');
       writeln(f,'swapping off');
       writeln(f,'c:\work\dosenh\numoff');
       writeln(f,'cd c:\modem\telix');
       writeln(f,'type \portada.txt');
       writeln(f,'delay 3');
       writeln(f,'cls');
       writeln(f,'set c:\4dos\4dos.set');
       writeln(f,'c:\work\varios\dispos');
       writeln(f,'swapping on');
       writeln(f,'telix');
       writeln(f,'call autoexec.bat');
       close(f);
       halt;
  end;

begin
     if buscar('spectrum') then spectrum else
     if buscar('ibmps2')   then ibmps2   else
     if buscar('kermit')   then kermit   else
     if buscar('bbstel')   then bbstel   else
       begin
            writeln;
            writeln(' Nombre de host incorrecto.');
            writeln;
       end;
end;

procedure mostrar;

  procedure hosts;
  begin
       writeln;
       writeln(' HOSTs disponibles desde este terminal. ');
       writeln;
       writeln(' IBMPS2   -> Sistema IBM/PS2 - 286/287. ');
       writeln(' SPECTRUM -> Sistema Compatible Spectrum+2 48K/128K. ');
       writeln(' KERMIT   -> Conexin va modem a equipos UNIX/VAX. ');
       writeln(' BBSTEL   -> Conexin va modem a BBS''s. ');
       writeln;
  end;

  procedure memoria;
  begin
       writeln;
       writeln(' Memoria convencional libre: ',memavail,' bytes.');
       writeln;
  end;

begin
     if buscar('hosts')  then hosts   else
     if buscar('memory') then memoria else
       begin
            writeln;
            writeln(' Falta indicador de dispositivo a mostrar o indicador incorrecto. ');
            writeln;
       end;
end;

procedure ayuda;

  procedure mostrar;
  begin
       writeln;
       writeln(' Ayuda sobre el comando SHOW');
       writeln;
       writeln(' El comando SHOW posee las siguientes opciones: ');
       writeln;
       writeln(' hosts  -> Muestra las distintas maquinas sobre las que se puede trabajar.');
       writeln(' memory -> Muestra la memoria convencional libre.');
       writeln;
  end;

  procedure abrir;
  begin
       writeln;
       writeln(' Ayuda sobre el comando OPEN');
       writeln;
       writeln(' El comando OPEN  sirve  para activar una  maquina determinada.');
       writeln(' Para ello  bastara  con teclear "open <hosts>" para activar la');
       writeln(' maquina deseada.');
       writeln;
       writeln(' Para ver las posibles maquinas sobre las que se puede trabajar');
       writeln(' bastara con teclear "show hosts" desde el local.');
       writeln;
  end;

begin
     if buscar('show') then mostrar else
     if buscar('open') then abrir   else
       begin
            writeln;
            writeln(' Lista de comandos disponibles: ');
            writeln;
            writeln(' Open     Show');
            writeln;
            writeln(' Teclee "help <comando>" para acceder a la ayuda sobre un comando.');
            writeln(' Ejemplo: help open. ');
            writeln;
       end;
end;

procedure proceso;
var seguir : boolean;
    n : integer;
begin
     seguir := true;
     repeat
           for n := 1 to 80 do cad[n] := ' ';
           write(' Local> ');
           readln(cad);
           if buscar('help') then ayuda else
           if buscar('open')  then abrir  else
           if buscar('show')  then mostrar else
           if buscar('bye')   then halt;
     until not seguir;
end;

BEGIN

      inicio;
      proceso;

END.










