Uses
  Dos;

Type
  Reg       : Registers;
  DelayHook : Function : Boolean;

{
   This proc Uses the AT BIOS' Wait Function: INT 15h, FUNC 86h. It's
   called With a LongInt in CX:DX. Its resolution is ca. 1 microsecond.
}

Procedure DelayIt(S : Word; Hook : DelayHook);
Var
  dly : LongInt;
  bdy : Boolean;
begin
  Repeat
    Reg.AH := $86;
    Reg.CX := 0;
    Reg.DX := 10000; { Wait 0.01 sec. }
    Intr($15, Reg);
  Until Hook;
end;
