program variar_fecha(input,output,f);

uses crt,dos;

type reg = record
         dia,mes,ano : word;
     end;

var f : file of reg;
    diasem,dia,mes,ano : word;
    fecha : reg;
    cad : string[80];
    n : integer;

procedure poner_autor;
begin
     writeln;
     writeln(' Grabador/Recuperador de Fecha del Sistema. ');
     writeln(' Versin 1.0. ');
     writeln;
     writeln(' Autor: Alvaro Canteiro Martinez. ');
     writeln;
     writeln;
end;

procedure cuadro;
begin
     clrscr;
     writeln('ͻ');
     writeln('                                                                           ');
     writeln(' Este programa ha sido donado por el autor para el dominio pblico, por lo ');
     writeln(' cual su distribucin es libre y gratuita estanto totalmente libre de toda ');
     writeln(' carga econmica. El autor  no  se  responsabiliza de cualquier dao, que, ');
     writeln(' directa o indirectamente, este programa pueda causar,  bien  sea un  dao ');
     writeln(' relativo al software o al hardware.                                       ');
     writeln('                                                                           ');
     writeln(' Autor: Alvaro Canteiro Martinez.      Internet: siacamaa@sisz00.si.ehu.es ');
     writeln('                                        FidoNet: 2:344/17.25               ');
     writeln('ͼ');
     writeln;
     halt;
end;

procedure grabar;
begin
     writeln(' Grabando fecha actual del sistema... ');
     getdate(ano,mes,dia,diasem);
     assign(f,'c:\varfecha.rec');
     rewrite(f);
     fecha.dia := dia;
     fecha.mes := mes;
     fecha.ano := ano;
     write(f,fecha);
     close(f);
end;

procedure recuperar;
begin
     writeln(' Recuperando fecha actual del sistema.... ');
     assign(f,'c:\varfecha.rec');
     reset(f);
     read(f,fecha);
     close(f);
     erase(f);
     setdate(fecha.ano,fecha.mes,fecha.dia);
end;

procedure mostrar_ayuda;
var s : char;
begin
     writeln;
     writeln(' Opciones en linea de comandos: ');
     writeln;
     writeln(' varfecha /?   ->    Mostrar ayuda. ');
     writeln(' varfecha /g   ->    Graba fecha actual. ');
     writeln(' varfecha /r   ->    Recupera fecha anteriormente grabada. ');
     writeln;
     writeln(' Pulse una tecla para seguir ... ');
     s := readkey;
     clrscr;
     cuadro;
end;

procedure procedimientos_iniciales;
begin
     for n := 1 to 80 do cad[n] := ' ';
     cad := getenv('CMDLINE');
end;

procedure proceso;
begin
      n := 1;
      while (cad[n] <> '/') and (n <= 80) do n := n + 1;
      if (cad[n+1] = 'g') or (cad[n+1] = 'G') then grabar
            else if (cad[n+1] = 'r') or (cad[n+1] = 'R') then recuperar
                else mostrar_ayuda;
end;


BEGIN

     
      poner_autor;
      procedimientos_iniciales;
      proceso;
 

END.





